        <xsl:variable name="classname">
            <xsl:call-template name="hbm2all:name.toUnqualifiedClassname">
                <xsl:with-param name="name" select="@name"  />
            </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="seamname">
            <xsl:call-template name="hbm2all:string.toLowerCamel">
                <xsl:with-param name="string" select="$classname"  />
            </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="table">
            <xsl:choose>
                <xsl:when test="@table">
                    <xsl:value-of select="@table" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="@name" />
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:variable name="identifier.name">
            <xsl:choose>
                <xsl:when test="id/@name">
                    <xsl:value-of select="id/@name"/>
                </xsl:when>
                <xsl:when test="@extends">
                    <xsl:call-template name="hbm2all:get.superclass.identifier">
                        <xsl:with-param name="superclass" select="@extends" />
                    </xsl:call-template>
                </xsl:when>
            </xsl:choose>
        </xsl:variable>
        <xsl:variable name="identifier.getter">
            <xsl:call-template name="propertyName.toGetter">
                <xsl:with-param name="propertyName" select="$identifier.name"/>
            </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="identifier.setter">
            <xsl:text>set</xsl:text>
            <xsl:call-template name="hbm2all:string.toUpperCamel">
                <xsl:with-param name="string" select="$identifier.name"/>
            </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="identifier.generator">
            <xsl:choose>
                <xsl:when test="id">
                    <xsl:value-of select="id/generator/@class"/>
                </xsl:when>
                <xsl:when test="@extends">
                    <xsl:call-template name="hbm2all:get.superclass.identifier.generator">
                        <xsl:with-param name="superclass" select="@extends" />
                    </xsl:call-template>
                </xsl:when>
            </xsl:choose>
        </xsl:variable>
        <xsl:variable name="identifier.type">
        		<xsl:call-template name="hbm2all:type.hbm2JavaType">
                <xsl:with-param name="type">
	                <xsl:choose>
			            <xsl:when test="id">
			            	   <xsl:value-of select="id/@type"/>
			            </xsl:when>
			            <xsl:when test="@extends">
			                 <xsl:call-template name="hbm2all:get.superclass.identifier.type">
	                        		<xsl:with-param name="superclass" select="@extends" />
	                    		</xsl:call-template>
			            </xsl:when>
			        </xsl:choose>
                </xsl:with-param>
            </xsl:call-template>
        </xsl:variable>
        
        
        <xsl:variable name="full.classname" select="concat($package, '.', $classname)"/>
        <xsl:variable name="formType">
        	<xsl:choose>
        		<xsl:when test="contains($actionType, 'Search')">
        			 <xsl:value-of select="'Search'"/>
        		</xsl:when>
        		<xsl:otherwise>
        			<xsl:value-of select="'Crud'"/>
        		</xsl:otherwise>
        	</xsl:choose>
        </xsl:variable>
        
        <xsl:variable name="form.classname">
			<xsl:value-of select="concat($classname, $formType, 'Form')"/>
        </xsl:variable>
        <xsl:variable name="action.classname" select="concat($classname, $actionType, 'Action')"/>
        <xsl:variable name="action.path" select="concat('/', $classname, '/', $actionType)"/>
        <xsl:variable name="input.path">
            <xsl:choose>
                <xsl:when test="$actionType = 'View' or $actionType = 'LoadCreate' or $actionType = 'LoadUpdate'">
                    <xsl:value-of select="'/global/error.jsp'"/>
                </xsl:when>
                <xsl:when test="$actionType = 'Search'">
                    <xsl:value-of select="concat('/', $classname, '/Search.jsp')"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="concat('/', $classname, '/Load', $actionType, '.do')"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:variable name="view.path">
            <xsl:choose>
                <xsl:when test="$actionType = 'View'">
                    <xsl:value-of select="concat('/', $classname, '/View.jsp')"/>
                </xsl:when>
                <xsl:when test="$actionType = 'LoadSearch'">
                    <xsl:value-of select="concat('/', $classname, '/Search.jsp')"/>
                </xsl:when>
                <xsl:when test="$actionType = 'LoadCreate'">
                    <xsl:value-of select="concat('/', $classname, '/Create.jsp')"/>
                </xsl:when>
                <xsl:when test="$actionType = 'LoadUpdate'">
                    <xsl:value-of select="concat('/', $classname, '/Update.jsp')"/>
                </xsl:when>
                <xsl:when test="$actionType = 'Create' or $actionType = 'Update'">
                    <xsl:value-of select="concat('/', $classname, '/View.do')"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="concat('/', $classname, '/', $actionType, '.jsp')"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <!--xsl:variable name="jsp.viewname" select="concat($classname, $actionType, 'View')"/-->
        <!-- TODO: make conditional to use the appropriate input  -->
        <xsl:variable name="jsp.inputname" select="concat($classname, $actionType, 'Input')"/>
        <xsl:variable name="ejb.remote.classname" select="concat($classname, 'Manager')"/>
        <xsl:variable name="ejb.local.classname" select="concat($classname, 'ManagerLocal')"/>
        <xsl:variable name="ejb.util.classname" select="concat($classname, 'ManagerUtil')"/>
        <xsl:variable name="ejb.classname">
            <xsl:choose>
                <xsl:when test="$remoteEjbViewMethod = 'false'">
                    <xsl:value-of select="$ejb.local.classname"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$ejb.remote.classname"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        
        