<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE includes [
  <!ENTITY classScopeVars SYSTEM "classTemplateVars.inc">
  <!ENTITY propertyScopeVars SYSTEM "propertyScopeVars.inc">
  <!ENTITY getParams SYSTEM "getParams.xml">
  ]>
<!-- 
    /*
    * Copyright 2004-2005 Emmanouil Batsis
    * 
    * Licensed under the GNU General Public License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    * 
    *      http://www.gnu.org/licenses/gpl.txt
    * 
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * 
    */
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xalan="http://xml.apache.org/xalan" 
    xmlns:hbm2all="http://geekologue.com/ns/hbm4all/" 
    xmlns:md4j="http://geekologue.com/md4j/"
    xmlns:jsp="http://java.sun.com/JSP/Page"
    xmlns:bean="http://struts.apache.org/tags-bean"   
    xmlns:html="http://struts.apache.org/tags-html"
    xmlns:logic="http://struts.apache.org/tags-logic">
    
    <xsl:output method="xml" indent="yes" xalan:indent-amount="3"  encoding="UTF-8" media-type="text/x-java-source"/>
    
    <xsl:include href="hbm2all-util.xsl"/>
    
    <xsl:template name="class" match="class|joined-subclass|subclass">
        <xsl:variable name="action" select="translate($actionType, $uppercase, $lowercase)" />
        <jsp:root version="2.0">
            <jsp:directive.page contentType="text/html; charset=utf-8" language="java"/>
            &classScopeVars;
            <!--jsp:directive.page import="gr.abiss.md4j.dao.Page;" /-->
            <jsp:directive.page import="{$full.classname}" />
            <html:javascript formName="{$form.classname}" />
            <html:errors />
            <!-- TODO: header and heading elements here -->
            <html:form action="{$action.path}" method="post" onsubmit="return validate{$form.classname}(this);">
                <table summary="Submission of {$classname}" class="form">     
                    <!--td><input type="text" name="senderName" class="grey" readonly="readonly" value="${identity.user.name}" size="50" /></td-->
                    <xsl:call-template name="renderFormTable">
                        <xsl:with-param name="action" select="$action" />
                    </xsl:call-template>
                    <tr>
                        <td>
                            <button type="submit">Submit</button>
                        </td>
                        <td>
                            <button type="reset">Reset</button>
                        </td>
                    </tr>
                </table>
                <xsl:call-template name="renderFormHiddenFields">
                    <xsl:with-param name="action" select="$action" />
                </xsl:call-template>
            </html:form>
             <!-- TODO: make footer here -->
         </jsp:root>
     </xsl:template>
    <xsl:template name="renderFormTable">
        <xsl:param name="action"/>
        <xsl:if test="contains(local-name(), 'subclass')">
            <xsl:variable name="superclass">
                <xsl:call-template name="hbm2all:name.toUnqualifiedClassname">
                    <xsl:with-param name="name" select="@extends" />
                </xsl:call-template>
            </xsl:variable>
            <xsl:for-each select="document(concat($superclass, '.hbm.xml'), .)/hibernate-mapping/class[@name = $superclass]">
                <xsl:call-template name="renderFormTable" />
            </xsl:for-each>
        </xsl:if>
        <xsl:comment>Properties of <xsl:value-of select="@name"/>: </xsl:comment>
        <xsl:for-each select="id[generator/@class='assiged'] | property[not(@formula)] | many-to-one">
            &propertyScopeVars;
            <tr>
                <td class="title">
                    <label for="{@name}">
                        <xsl:choose>
                            <xsl:when test="meta/@attribute[local-name() = 'md4j:form-label-key']">
                                <bean:message key="{meta/@attribute[local-name() = 'md4j:form-label-key']}"/>
                            </xsl:when>
                            <xsl:when test="meta/@attribute[local-name() = 'md4j:form-label']">
                                <xsl:value-of select="meta/@attribute[local-name() = 'md4j:form-label']"/>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:value-of select="@name"/>
                            </xsl:otherwise>
                        </xsl:choose>
                        <xsl:text>: </xsl:text>
                    </label>
                </td>
                <td>
                    <html:text property="{@name}">
                        <xsl:if test="@length">
                            <xsl:attribute name="maxLength">
                                <xsl:value-of select="@length"/>
                            </xsl:attribute>
                        </xsl:if>
                        <xsl:if test="local-name() = 'id' and $action = 'update'">
                            <xsl:attribute name="disabled">
                                <xsl:value-of select="'disabled'"/>
                            </xsl:attribute>
                        </xsl:if>
                    </html:text>
                </td>   
            </tr>
        </xsl:for-each>
    </xsl:template>
    <xsl:template name="renderFormHiddenFields">
        <xsl:param name="action"/>
        <xsl:if test="contains(local-name(), 'subclass')">
            <xsl:variable name="superclass">
                <xsl:call-template name="hbm2all:name.toUnqualifiedClassname">
                    <xsl:with-param name="name" select="@extends" />
                </xsl:call-template>
            </xsl:variable>
            <xsl:for-each select="document(concat($superclass, '.hbm.xml'), .)/hibernate-mapping/class[@name = $superclass]">
                <xsl:call-template name="renderFormHiddenFields" />
            </xsl:for-each>
        </xsl:if>
        <xsl:for-each select="id[not(generator/@class='assiged')]">
            &propertyScopeVars;
            <html:hidden property="{@name}" />
        </xsl:for-each>
    </xsl:template>
    
</xsl:stylesheet>