<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE includes [
  <!ENTITY classScopeVars SYSTEM "classTemplateVars.inc">
  <!ENTITY propertyScopeVars SYSTEM "propertyScopeVars.inc">
  <!ENTITY getParams SYSTEM "getParams.xml">
  <!ENTITY licenseBlock SYSTEM "license.inc">
  ]>   
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
    xmlns:hbm2all="http://geekologue.com/ns/hbm4all/">
    <xsl:output method="text" encoding="UTF-8" media-type="text/x-java-source"/>
    <xsl:include href="md4j-util.xsl"/>
    <!--xsl:param name="package" select="&apos;gr.geekologue.hbm2all.web.default&apos;"/>
    <xsl:variable name="hbmGlobalPackage" select="/hibernate-mapping/@package"/>
    <xsl:param name="pageAttributeName" select="&apos;&apos;"/-->
    <xsl:param name="ejbMethod" select="&apos;remote&apos;"/>
    <xsl:param name="singletonDaos" select="&apos;false&apos;"/>
    <xsl:template name="class" match="class|joined-subclass|subclass">
        <xsl:variable name="implements" select="&apos;SessionBean&apos;"/>
        &classScopeVars;
        <xsl:text>&licenseBlock;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:value-of select="concat(&apos;package &apos;, $package,&apos;.business;&#10;&apos;)"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import java.io.Serializable;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import java.util.List;&#10;</xsl:text>
        <xsl:text>import java.util.Set;&#10;</xsl:text>
        <xsl:text>import java.util.HashSet;&#10;</xsl:text>
        <xsl:text>import java.util.Map;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import javax.ejb.CreateException;&#10;</xsl:text>
        <xsl:text>import javax.ejb.EJBException;&#10;</xsl:text>
        <xsl:text>import javax.ejb.SessionBean;&#10;</xsl:text>
        <xsl:text>import javax.ejb.SessionContext;&#10;</xsl:text>
        <xsl:text>import javax.naming.InitialContext;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <!--xsl:text>import org.hibernate.Criteria;&#10;</xsl:text>
        <xsl:text>import org.hibernate.HibernateException;&#10;</xsl:text>
        <xsl:text>import org.hibernate.Query;&#10;</xsl:text>
        <xsl:text>import org.hibernate.Session;&#10;</xsl:text>
        <xsl:text>import org.hibernate.SessionFactory;&#10;</xsl:text>
        <xsl:text>import org.hibernate.criterion.Expression;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text-->
        <xsl:text>import org.apache.log4j.Logger;&#10;</xsl:text>
        <xsl:text>import org.apache.commons.lang.math.NumberUtils;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import gr.abiss.md4j.dao.Page;&#10;</xsl:text>
        <xsl:text>import gr.abiss.md4j.dao.Order;&#10;</xsl:text>
        <xsl:text>import gr.abiss.md4j.business.BrokenConstraintsException;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        
        <xsl:call-template name="hbm2all:resolve.pojo.imports" />
        <xsl:text>&#10;</xsl:text>
        <xsl:value-of select="concat('import ', $full.classname, ';&#10;')"/>
        <xsl:value-of select="concat('import ', $package, '.dao.', $classname, 'DAO;&#10;')"/>
        <xsl:text>/**&#10;</xsl:text>
        <xsl:value-of select="concat(' * @ejb.bean name=&quot;', $classname, 'Manager&quot;&#10;')"/>
        <xsl:value-of select="concat(' *           display-name=&quot;',$classname, 'Manager&quot;&#10;')"/>
        <xsl:value-of select="concat(' *           description=&quot;', $classname, ' EJB&quot;&#10;')"/>
        <xsl:value-of select="concat(' *           jndi-name=&quot;ejb/', $classname, 'ManagerBeanHome&quot;&#10;')"/>
        <xsl:value-of select="concat(' *           local-jndi-name=&quot;ejb/', $classname, 'ManagerBeanLocalHome&quot;&#10;')"/>
        <xsl:value-of select="concat(' *           view-type=&quot;', $ejbViewMethod, '&quot;&#10;')"/>
        <xsl:text> *           type="Stateless"&#10;</xsl:text>
        <!-- required for inheritance to work with Util Objects -->
        <xsl:text> * @ejb.home extends="javax.ejb.EJBHome" local-extends="javax.ejb.EJBLocalHome"&#10;</xsl:text>
        <xsl:text> * @ejb.transaction type="Required"&#10;</xsl:text>
        
        <xsl:text> *&#10;</xsl:text>
        <!-- 
            TODO: Add local
        -->
        <!--xsl:if test="$ejbViewMethod = 'both' or $ejbViewMethod = 'remote'">
            <xsl:value-of select="concat(' * @ejb.interface remote-class=&quot;', $package, '.business.interfaces.', $ejb.classname, '&quot;&#10;')"/>
        </xsl:if-->
        <xsl:text> * @ejb.interface&#10;</xsl:text>
        <xsl:text> *&#10;</xsl:text>
        <xsl:text> */&#10;</xsl:text>
        <xsl:value-of select="concat('public class ', $classname, 'ManagerBean')"/>
        <xsl:if test="contains(local-name(), 'subclass')">
            <xsl:value-of select="concat(' extends ', @extends, 'ManagerBean')"/>
        </xsl:if>
        <xsl:value-of select="concat(' implements ', $implements, '{&#10;')"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:value-of select="concat('    private static Logger log = Logger.getLogger(', $classname, 'ManagerBean.class);&#10;')"/>
        <xsl:text> &#10;</xsl:text>
        <!--xsl:text>    private SessionFactory sf;&#10;</xsl:text-->
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:text>     * @ejb.create-method&#10;</xsl:text>
        <xsl:text>     */&#10;</xsl:text>
        <xsl:text>    public void ejbCreate() throws CreateException {&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    public void ejbActivate() throws EJBException {&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    public void ejbPassivate() throws EJBException {&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    public void ejbRemove() throws EJBException {&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    public void setSessionContext(SessionContext newContext) throws EJBException {&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:text>     * Get a page of results matching the given parameters&#10;</xsl:text>
        <xsl:text>     * @param params the search parameters&#10;</xsl:text>
        <xsl:text>     * @param pageNumber the results page number &#10;</xsl:text>
        <xsl:text>     * @param pageSize the results page size&#10;</xsl:text>
        <xsl:text>     * @return a search results page constructed based on the given parameters&#10;</xsl:text>
        <xsl:text>     * &#10;</xsl:text>
        <xsl:value-of select="concat('     * @ejb.interface-method view-type = &quot;', $ejbMethod, '&quot;&#10;')"/>
        <xsl:text>     * @throws EJBException&#10;</xsl:text>
        <xsl:text>     */&#10;</xsl:text>
        <xsl:text>    public Page search(Map params, Order order, int pageNumber, int pageSize) throws EJBException {&#10;</xsl:text>
        <xsl:text>        Page page = null;&#10;</xsl:text>
        <xsl:text>        try {&#10;</xsl:text>
        <xsl:call-template name="getDataAccessObject">
            <xsl:with-param name="classname" select="$classname" />
            <xsl:with-param name="whitespace" select="'            '" />
        </xsl:call-template>
        <xsl:text>            page = dao.getPage(params, order, pageNumber, pageSize);&#10;</xsl:text>
        <xsl:text>        } catch (Exception e) {&#10;</xsl:text>
        <xsl:text>            throw new EJBException(e);&#10;</xsl:text>
        <xsl:text>        }&#10;</xsl:text>
        <xsl:text>        return page;&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:text>     * Get a page of results matching the given parameters&#10;</xsl:text>
        <xsl:text>     * @param params the search parameters&#10;</xsl:text>
        <xsl:text>     * @param pageNumber the results page number &#10;</xsl:text>
        <xsl:text>     * @param pageSize the results page size&#10;</xsl:text>
        <xsl:text>     * @return a search results page constructed based on the given parameters&#10;</xsl:text>
        <xsl:text>     * &#10;</xsl:text>
        <xsl:value-of select="concat('     * @ejb.interface-method view-type = &quot;', $ejbMethod, '&quot;&#10;')"/>
        <xsl:text>     * @throws EJBException&#10;</xsl:text>
        <xsl:text>     */&#10;</xsl:text>
        <xsl:text>    public Page search(Set projectionProps, Map params, Order order, int pageNumber, int pageSize) throws EJBException {&#10;</xsl:text>
        <xsl:text>        Page page = null;&#10;</xsl:text>
        <xsl:text>        try {&#10;</xsl:text>
        <xsl:call-template name="getDataAccessObject">
            <xsl:with-param name="classname" select="$classname" />
            <xsl:with-param name="whitespace" select="'            '" />
        </xsl:call-template>
        <xsl:text>            page = dao.getPage(projectionProps, params, order, pageNumber, pageSize);&#10;</xsl:text>
        <xsl:text>        } catch (Exception e) {&#10;</xsl:text>
        <xsl:text>            throw new EJBException(e);&#10;</xsl:text>
        <xsl:text>        }&#10;</xsl:text>
        <xsl:text>        return page;&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:variable name="id.name">
            <xsl:choose>
                <xsl:when test="local-name() = 'joined-subclass'">
                    <xsl:call-template name="hbm2all:get.superclass.identifier">
                        <xsl:with-param name="superclass" select="@extends" />
                    </xsl:call-template>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="@name"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:variable name="isAssigned">
            <xsl:choose>
                <xsl:when test="id/generator/@class='assigned'">
                    <xsl:value-of select="'true'"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="'false'"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:variable name="returnType">
            <!--xsl:choose>
                <xsl:when test="id/generator/@class='assigned'">
                    <xsl:value-of select="'void'"/>
                </xsl:when>
                <xsl:otherwise-->
                    <xsl:value-of select="'Serializable'"/>
                <!--/xsl:otherwise>
            </xsl:choose-->
        </xsl:variable>
        <xsl:text>&#10;</xsl:text>
        <xsl:if test="local-name() = 'class'">
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:value-of select="concat('     * Save a new ', $classname, ' instance based on the property-value pairs in the map  &#10;')"/>
            <xsl:text>     * @param map&#10;</xsl:text>
            <!--xsl:if test="$isAssigned = 'false'"-->
                <xsl:value-of select="concat('     * @return the persisted ', $classname, ' instance identifier &#10;')"/>
            <!--/xsl:if-->
            <xsl:text>     * &#10;</xsl:text>
            <xsl:value-of select="concat('     * @ejb.interface-method view-type = &quot;', $ejbMethod, '&quot;&#10;')"/>
            <xsl:text>     * @throws javax.ejb.EJBException possibly wrapping a BrokenConstraintsException &#10;</xsl:text>
            <xsl:text>     * @ejb.transaction type="Required"&#10;</xsl:text>
            <xsl:text>     */&#10;</xsl:text>
            <xsl:value-of select="concat('    public ', $returnType, ' save(Map map) throws EJBException {&#10;')"/>
            <xsl:text>        try {&#10;</xsl:text>
            <xsl:call-template name="getDataAccessObject">
                <xsl:with-param name="classname" select="$classname" />
                <xsl:with-param name="whitespace" select="'            '" />
            </xsl:call-template>
            <xsl:text>            // check for unique constraint violations&#10;</xsl:text>
            <xsl:text>            Set brokens = dao.getBrokenUConstraints(map, null);&#10;</xsl:text>
            
            <xsl:text>            log.info("Broken constaints: "+ brokens.size());&#10;</xsl:text>
            <xsl:text>            if(brokens != null &amp;&amp; brokens.size() &gt; 0){&#10;</xsl:text>
            <xsl:text>                throw new BrokenConstraintsException(brokens);&#10;</xsl:text>
            <xsl:text>            }&#10;</xsl:text>
            <xsl:text>            </xsl:text>
            <!--xsl:if test="$isAssigned = 'false'"-->
                <xsl:text>return </xsl:text>
            <!--/xsl:if-->
            <xsl:text>dao.save(map);&#10;</xsl:text>
            <xsl:text>        } catch (Exception e) {&#10;</xsl:text>
            <xsl:text>            throw new EJBException(e);&#10;</xsl:text>
            <xsl:text>        }&#10;</xsl:text>
            <xsl:text>    }&#10;</xsl:text>
            <!-- temp -->
            <!--xsl:text>&#10;</xsl:text>
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:value-of select="concat('     * Save a new ', $classname, ' instance  &#10;')"/>
            <xsl:text>     * @param map&#10;</xsl:text>
            <xsl:value-of select="concat('     * @return the persisted ', $classname, ' instance  &#10;')"/>
            <xsl:text>     * &#10;</xsl:text>
            <xsl:value-of select="concat('     * @ejb.interface-method view-type = &quot;', $ejbMethod, '&quot;&#10;')"/>
            <xsl:text>     * @throws EJBException&#10;</xsl:text>
            <xsl:text>     * @ejb.transaction type="Required"&#10;</xsl:text>
            <xsl:text>     */&#10;</xsl:text>
            <xsl:value-of select="concat('    public ', $classname, ' save(', $classname, ' pojo) throws EJBException {&#10;')"/>
            <xsl:text>        try {&#10;</xsl:text>
            <xsl:call-template name="getDataAccessObject">
                <xsl:with-param name="classname" select="$classname" />
                <xsl:with-param name="whitespace" select="'            '" />
            </xsl:call-template>
            <xsl:value-of select="concat('            pojo = (', $classname, ') (dao.save(pojo));&#10;')"/>
            <xsl:text>        } catch (Exception e) {&#10;</xsl:text>
            <xsl:text>            throw new EJBException(e);&#10;</xsl:text>
            <xsl:text>        }&#10;</xsl:text>
            <xsl:text>        return pojo;&#10;</xsl:text>
            <xsl:text>    }&#10;</xsl:text-->
        </xsl:if>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:value-of select="concat('     * Retreive the ', $classname, ' matching the given identifier if any such match is found, &lt;code&gt;null&lt;/code&gt; otherwise&#10;')"/>
        <xsl:value-of select="concat('     * @return the ', $classname, ' matching the given identifier if any such match is found, &lt;code&gt;null&lt;/code&gt; otherwise&#10;')"/>
        <xsl:text>     * &#10;</xsl:text>
        <xsl:value-of select="concat('     * @ejb.interface-method view-type = &quot;', $ejbMethod, '&quot;&#10;')"/>
        <xsl:text>     * @throws EJBException&#10;</xsl:text>
        <xsl:text>     */&#10;</xsl:text>
        <xsl:text>    public Serializable get(Serializable identifier) throws EJBException {&#10;</xsl:text>
        <xsl:text>        Serializable pojo = null;&#10;</xsl:text>
        <xsl:text>        try {&#10;</xsl:text>
        <xsl:call-template name="getDataAccessObject">
            <xsl:with-param name="classname" select="$classname" />
            <xsl:with-param name="whitespace" select="'            '" />
        </xsl:call-template>
        <xsl:text>            pojo = (Serializable) dao.get(identifier);&#10;</xsl:text>
        <xsl:text>        } catch (Exception e) {&#10;</xsl:text>
        <xsl:text>            throw new EJBException(e);&#10;</xsl:text>
        <xsl:text>        }&#10;</xsl:text>
        <xsl:text>        return pojo;&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:value-of select="concat('     * Retreive the ', $classname, ' matching the given identifier as a map if any such match is found, &lt;code&gt;null&lt;/code&gt; otherwise&#10;')"/>
        <xsl:value-of select="concat('     * @return the ', $classname, ' matching the given identifier as a map if any such match is found, &lt;code&gt;null&lt;/code&gt; otherwise&#10;')"/>
        <xsl:text>     * &#10;</xsl:text>
        <xsl:value-of select="concat('     * @ejb.interface-method view-type = &quot;', $ejbMethod, '&quot;&#10;')"/>
        <xsl:text>     * @throws EJBException&#10;</xsl:text>
        <xsl:text>     */&#10;</xsl:text>
        <xsl:text>    public Map get(Serializable identifier, Set projectionProperties) throws EJBException {&#10;</xsl:text>
        <xsl:text>        Map map = null;&#10;</xsl:text>
        <xsl:text>        try {&#10;</xsl:text>
        <xsl:call-template name="getDataAccessObject">
            <xsl:with-param name="classname" select="$classname" />
            <xsl:with-param name="whitespace" select="'            '" />
        </xsl:call-template>
        <xsl:text>            map = dao.get(identifier, projectionProperties);&#10;</xsl:text>
        <xsl:text>        } catch (Exception e) {&#10;</xsl:text>
        <xsl:text>            throw new EJBException(e);&#10;</xsl:text>
        <xsl:text>        }&#10;</xsl:text>
        <xsl:text>        return map;&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:value-of select="concat('     * Retreive the requested properties of the ', $classname, ' matching the given identifier as a map that &lt;b&gt;includes parent options for the web tier&lt;b&gt;&#10;')"/>
        <xsl:value-of select="concat('     * The parent options are essentially the data needed to construct HTML select elements in views. &#10;', '')"/>
        <xsl:value-of select="concat('     * @return the map containing the bunch if a match for the identifier is found, &lt;code&gt;null&lt;/code&gt; otherwise&#10;', '')"/>
        <xsl:text>     * &#10;</xsl:text>
        <xsl:value-of select="concat('     * @ejb.interface-method view-type = &quot;', $ejbMethod, '&quot;&#10;')"/>
        <xsl:text>     * @throws EJBException&#10;</xsl:text>
        <xsl:text>     */&#10;</xsl:text>
        <xsl:text>    public Map getWithOptions(Serializable identifier, Set projectionProperties) throws EJBException {&#10;</xsl:text>
        <xsl:text>        Map map = null;&#10;</xsl:text>
        <xsl:text>        try {&#10;</xsl:text>
        <xsl:call-template name="getDataAccessObject">
            <xsl:with-param name="classname" select="$classname" />
            <xsl:with-param name="whitespace" select="'            '" />
        </xsl:call-template>
        <xsl:text>            map = dao.get(identifier, projectionProperties);&#10;</xsl:text>
        <xsl:text>            // add data for form drop downs refering to parent classes&#10;</xsl:text>
        <xsl:text>            dao.addParentOptions(map);&#10;</xsl:text>
        <xsl:text>        } catch (Exception e) {&#10;</xsl:text>
        <xsl:text>            throw new EJBException(e);&#10;</xsl:text>
        <xsl:text>        }&#10;</xsl:text>
        <xsl:text>        return map;&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    /**&#10;</xsl:text>
        <!--xsl:value-of select="concat('     * Retreive the ', $classname, ' matching the given identifier as a map if any such match is found, &lt;code&gt;null&lt;/code&gt; otherwise&#10;')"/>
        <xsl:value-of select="concat('     * @return the ', $classname, ' matching the given identifier as a map if any such match is found, &lt;code&gt;null&lt;/code&gt; otherwise&#10;')"/-->
        <xsl:text>     * &#10;</xsl:text>
        <xsl:value-of select="concat('     * @ejb.interface-method view-type = &quot;', $ejbMethod, '&quot;&#10;')"/>
        <xsl:text>     * @throws EJBException&#10;</xsl:text>
        <xsl:text>     */&#10;</xsl:text>
        <xsl:text>    public Map getParentOptions() throws EJBException {&#10;</xsl:text>
        <xsl:text>        Map map = null;&#10;</xsl:text>
        <xsl:text>        try {&#10;</xsl:text>
        <xsl:call-template name="getDataAccessObject">
            <xsl:with-param name="classname" select="$classname" />
            <xsl:with-param name="whitespace" select="'            '" />
        </xsl:call-template>
        <xsl:text>            // get data for form drop downs refering to parent classes&#10;</xsl:text>
        <xsl:text>            map = dao.getParentOptions();&#10;</xsl:text>
        <xsl:text>        } catch (Exception e) {&#10;</xsl:text>
        <xsl:text>            throw new EJBException(e);&#10;</xsl:text>
        <xsl:text>        }&#10;</xsl:text>
        <xsl:text>        return map;&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:text>     * &#10;</xsl:text>
        <xsl:value-of select="concat('     * @ejb.interface-method view-type = &quot;', $ejbMethod, '&quot;&#10;')"/>
        <xsl:text>     * @throws EJBException&#10;</xsl:text>
        <xsl:text>     * @ejb.transaction type="Required"&#10;</xsl:text>
        <xsl:text>     */&#10;</xsl:text>
        <xsl:text>    public void update(Map map) throws EJBException {&#10;</xsl:text>
        <xsl:text>        try {&#10;</xsl:text>
        <xsl:call-template name="getDataAccessObject">
            <xsl:with-param name="classname" select="$classname" />
            <xsl:with-param name="whitespace" select="'            '" />
        </xsl:call-template>
        <xsl:value-of select="concat('            String sId = (String) map.get(&quot;', $identifier.name, '&quot;);&#10;')"/>
        <xsl:text>            if(sId != null){&#10;</xsl:text>
        <xsl:call-template name="fromStringIdToObject">
            <xsl:with-param name="identifier.type" select="$identifier.type"/>
            <xsl:with-param name="stringName" select="'sId'" />
            <xsl:with-param name="objectName" select="'id'" />
            <xsl:with-param name="indent" select="'               '"/>
        </xsl:call-template>
        <xsl:text>                // check for unique constraint violations&#10;</xsl:text>
        
        <xsl:value-of select="concat('                Set brokens = dao.getBrokenUConstraints(map, id);&#10;', '')"/>
        <xsl:text>                if(brokens != null &amp;&amp; brokens.size() &gt; 0){&#10;</xsl:text>
        <xsl:text>                    throw new BrokenConstraintsException(brokens);&#10;</xsl:text>
        <xsl:text>                }&#10;</xsl:text>
        
        <!--xsl:value-of select="concat('            // Serializable identifier = (Serializable) params.get(&quot;', $id.name, '&quot;);&#10;')" /-->
        <xsl:text>                dao.update(map);&#10;</xsl:text>
        <xsl:value-of select="concat('            ', '}&#10;')"/>
        <xsl:text>            else{&#10;</xsl:text>
        <xsl:text>                throw new Exception("Parameter id was null");&#10;</xsl:text>
        <xsl:text>            }&#10;</xsl:text>
        
        <xsl:text>        } catch (Exception e) {&#10;</xsl:text>
        <xsl:text>            throw new EJBException(e);&#10;</xsl:text>
        <xsl:text>        }&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:text>     * &#10;</xsl:text>
        <xsl:value-of select="concat('     * @ejb.interface-method view-type = &quot;', $ejbMethod, '&quot;&#10;')"/>
        <xsl:text>     * @throws EJBException&#10;</xsl:text>
        <xsl:text>     * @ejb.transaction type="Required"&#10;</xsl:text>
        <xsl:text>     */&#10;</xsl:text>
        <xsl:text>    public void delete(Serializable pojo) throws EJBException {&#10;</xsl:text>
        <xsl:text>        try {&#10;</xsl:text>
        <xsl:call-template name="getDataAccessObject">
            <xsl:with-param name="classname" select="$classname" />
            <xsl:with-param name="whitespace" select="'            '" />
        </xsl:call-template>
        <xsl:text>            dao.delete((Serializable) pojo);&#10;</xsl:text>
        <xsl:text>        } catch (Exception e) {&#10;</xsl:text>
        <xsl:text>            throw new EJBException(e);&#10;</xsl:text>
        <xsl:text>        }&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        
        <!-- finders -->
        <xsl:for-each select="property[meta[@attribute = 'md4j:generate-finder' and . = 'true']] | many-to-one[meta[@attribute = 'md4j:generate-finder' and . = 'true']]">
            &propertyScopeVars;
            <xsl:variable name="returnType">
                <xsl:choose>
                    <xsl:when test="@unique = 'true'">
                        <xsl:value-of select="$classname"/> 
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:text>Page</xsl:text>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>
            <xsl:variable name="many-to-one.identifier.name">
                <xsl:if test="local-name() = 'many-to-one'">
                    <xsl:value-of select="concat('.', $identifier.name)"/>
                </xsl:if>
            </xsl:variable>
            <xsl:variable name="pageParams">
                <xsl:if test="$returnType = 'Page'">
                    <xsl:text>, int pageNumber, int pageSize</xsl:text>
                </xsl:if>
            </xsl:variable>
            <xsl:variable name="finderName">
                <xsl:call-template name="hbm2all:string.toUpperCamel">
                    <xsl:with-param name="string" select="$name" />
                </xsl:call-template>
            </xsl:variable> 
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:text>     * &#10;</xsl:text>
            <xsl:value-of select="concat('     * @ejb.interface-method view-type = &quot;', $ejbMethod, '&quot;&#10;')"/>
            <xsl:text>     * @throws EJBException&#10;</xsl:text>
            <xsl:text>     */&#10;</xsl:text>
            <xsl:value-of select="concat('    public ', $returnType, ' findBy', $finderName, '(Serializable input, int pageNumber, int pageSize) {&#10;')"/>
            <xsl:call-template name="getDataAccessObject">
                <xsl:with-param name="classname" select="$classname" />
                <xsl:with-param name="whitespace" select="'        '" />
            </xsl:call-template>
            <xsl:value-of select="concat('        return dao.findBy', $finderName, '(input, pageNumber, pageSize);&#10;')"/>
            <xsl:text>    }&#10;</xsl:text>
        </xsl:for-each>
        
        <xsl:text>&#10;// comment&#10;</xsl:text>

        <xsl:text>&#10;} // Need to display&#10;</xsl:text>
    </xsl:template>
    
    <xsl:template name="getDataAccessObject">
        <xsl:param name="classname"/>
        <xsl:param name="whitespace"/>
        <xsl:choose>
            <xsl:when test="not($singletonDaos = 'true')">
                <xsl:value-of select="concat($whitespace, $classname, 'DAO dao = new ', $classname, 'DAO();&#10;')"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="concat($whitespace, $classname, 'DAO dao = (', $classname, 'DAO) ', $classname, 'DAO.getInstance();&#10;')"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
    
    </xsl:transform>
