<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE includes [
  <!ENTITY classScopeVars SYSTEM "classTemplateVars.inc">
  <!ENTITY propertyScopeVars SYSTEM "propertyScopeVars.inc">
  <!ENTITY getEJB SYSTEM "getEJB.inc">
  <!ENTITY licenseBlock SYSTEM "license.inc">
  ]>   
<!-- 
    /*
    * Copyright 2004-2005 Emmanouil Batsis
    * 
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    * 
    *      http://www.gnu.org/licenses/gpl.txt
    * 
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * 
    */
-->
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
    xmlns:hbm2all="http://geekologue.com/ns/hbm4all/" xmlns:md4j="http://geekologue.com/md4j/">
    <xsl:output method="text" encoding="UTF-8" media-type="text/x-java-source"/>
    
    <xsl:include href="md4j-util.xsl"/>
    <xsl:param name="seamscope" select="'SESSION'" />
    
    <xsl:template name="class" match="class | joined-subclass | subclass">
        &classScopeVars;
        <xsl:text>&licenseBlock;</xsl:text>
        <xsl:text>&#10;</xsl:text>    
        <xsl:value-of select="concat(&apos;package &apos;, $package,&apos;.business;&#10;&apos;)"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import java.io.Serializable;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import java.util.Map;&#10;</xsl:text>
        <xsl:text>import java.util.HashMap;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        
        <xsl:text>import gr.abiss.md4j.util.Md4jGlobals;&#10;</xsl:text>
        
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import org.apache.log4j.Logger;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>/**&#10;</xsl:text>
        
        <xsl:text> *&#10;</xsl:text>
        <xsl:text> */&#10;</xsl:text>
        <xsl:text>@Entity&#10;</xsl:text>
        <xsl:value-of select="concat('@Name(&quot;', $seamname, '&quot;)&#10;')"/>
        <xsl:value-of select="concat('@Scope(', $seamscope, ')&#10;')"/>
        <xsl:value-of select="concat('@Table(name=&quot;', $table, '&quot;)&#10;')"/>
        <xsl:value-of select="concat('public class ', $classname)"/>
        <xsl:if test="contains(local-name(), 'subclass')">
            <xsl:value-of select="concat(' extends ', @extends)"/>
        </xsl:if>
        <xsl:value-of select="concat(' implements Serializable', '{&#10;')"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:value-of select="concat('    private static Logger log = Logger.getLogger(', $classname, 'ManagerBean.class);&#10;')"/>
        
        
        
        
        
        <!-- property declarations first -->
        <xsl:for-each select="id | property[not(@formula)] | many-to-one | set | bag | list | array | map">
            &propertyScopeVars;
            <!--xsl:value-of select="concat('               // before property call: ', local-name(), ' element&#10;')"/-->
            <xsl:choose>
                <xsl:when test="string-length($type) &gt; 0">
                    <xsl:call-template name="property">
                        <xsl:with-param name="form.classname" select="$form.classname" />
                        <xsl:with-param name="name" select="$name" />
                        <xsl:with-param name="type" select="$type" />
                    </xsl:call-template>
                </xsl:when>
            </xsl:choose>
        </xsl:for-each>
        <!-- getters setters -->
        <xsl:text>&#10;</xsl:text>
        <xsl:for-each select="id | property[not(@formula)] | many-to-one | set | bag | list | array | map">
            &propertyScopeVars;
            <xsl:call-template name="propertyMethods">
                <xsl:with-param name="type" select="$type" />
            </xsl:call-template>
            
        </xsl:for-each>
        
        
        <xsl:text>&#10;</xsl:text>
        
        
        
        
        <xsl:text>&#10;}&#10;</xsl:text>
    </xsl:template>
    
    
    <xsl:template name="property" mode="property">
        <xsl:param name="name" />
        <xsl:param name="type" select="'String'" />
        <xsl:param name="description" select="''" />
        <xsl:param name="defaultValue" select="''" />
        
        <!--xsl:value-of select="concat('               // property: ', local-name(), ' element&#10;')"/-->
        <xsl:variable name="assignment">
            <xsl:if test="string-length($defaultValue) &gt; 0">
                <xsl:value-of select="concat(' = ', $defaultValue)"/>
            </xsl:if>
        </xsl:variable>
        <xsl:variable name="propertyDescription">
            <xsl:choose>
                <xsl:when test="string-length($description) &gt; 0">
                    <xsl:value-of select="$description"/>
                </xsl:when>    
                <xsl:otherwise>
                    <xsl:value-of select="@name"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:choose>
            <xsl:when test="$type = 'FormFile'">
                <xsl:text>&#10;</xsl:text>
                <xsl:text>    /**&#10;</xsl:text>
                <xsl:value-of select="concat('     * ', $propertyDescription, ' FormFile &#10;')" />
                <xsl:text>     */&#10;</xsl:text>
                <xsl:value-of select="concat('    private ', $type, ' ', $name, 'FormFile', $assignment, ';&#10;')"/>
                <xsl:text>&#10;</xsl:text>
                <xsl:text>    /**&#10;</xsl:text>
                <xsl:value-of select="concat('     * ', $propertyDescription, '&#10;')" />
                <xsl:text>     */&#10;</xsl:text>
                <xsl:value-of select="concat('    private ', 'String', ' ', $name, $assignment, ';&#10;')"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:text>&#10;</xsl:text>
                <xsl:text>    /**&#10;</xsl:text>
                <xsl:value-of select="concat('     * ', $propertyDescription, '&#10;')" />
                <xsl:text>     */&#10;</xsl:text>
                <xsl:value-of select="concat('    private ', $type, ' ', $name, $assignment, ';&#10;')"/>
            </xsl:otherwise>
        </xsl:choose>
        
    </xsl:template>
    
    <xsl:template name="propertyMethods" mode="propertyMethods">
        <xsl:param name="type" select="'String'" />
        
        <!--xsl:value-of select="concat('               // propertyMethods: ', local-name(), ' element&#10;')"/-->
        <xsl:variable name="beanMethodName">
            <xsl:call-template name="hbm2all:string.toUpperCamel">
                <xsl:with-param name="string" select="@name" />
            </xsl:call-template>
        </xsl:variable>
        
        <xsl:text>&#10;</xsl:text>
        <xsl:if test="local-name() = 'id'">
            <xsl:text>    @Id&#10;</xsl:text>
        </xsl:if>
        <xsl:if test="((not(local-name() = 'id') and (@not-null='true' or column/@not-null='true'))
            or (local-name() = 'id' and generator[@class = 'assigned'])
            )">
            <xsl:text>    @NotNull&#10;</xsl:text>
        </xsl:if> 
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:value-of select="concat('     * Get the ', @name, '&#10;')"/>
        <xsl:value-of select="concat('     * @return the ', @name, '&#10;')"/>
        <xsl:text>     */&#10;</xsl:text>
        <xsl:value-of select="concat('    public ', $type, ' get', $beanMethodName, '(){&#10;')"/>
        <xsl:value-of select="concat('        return this.', @name, ';&#10;')"/>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:value-of select="concat('     * Set the ', @name, '&#10;')"/>
        <xsl:value-of select="concat('     * @param ', @name, ' the ', @name, $suffix, ' to set&#10;')"/>
        <xsl:if test="string-length($struts.validator.type) &gt; 0">
            <xsl:choose>
                <xsl:when test="contains($struts.validator.type, 'boolean')">
                    <!-- emulate boolean by enforcing either 0 or 1 -->
                    <xsl:text>     * @struts.validator type=&quot;</xsl:text>
                    <xsl:if test="contains($struts.validator.type, 'required')">
                        <xsl:text>required,</xsl:text>
                    </xsl:if>
                    <xsl:text>validwhen</xsl:text>
                    <xsl:text>&quot; msgkey=&quot;boolean&quot;&#10;</xsl:text>
                    <xsl:choose>
                        <xsl:when test="$actionType = 'Search'">
                            <xsl:text>     * @struts.validator-var name=&quot;test&quot; value=&quot;((*this* == null) or ((*this* == 'true') or (*this* == 'false')))&quot;&#10;</xsl:text>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:text>     * @struts.validator-var name=&quot;test&quot; value=&quot;((*this* == 'true') or (*this* == 'false'))&quot;&#10;</xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="concat('     * @struts.validator type=&quot;', $struts.validator.type, '&quot;&#10;')" />
                </xsl:otherwise>
            </xsl:choose>
            <xsl:choose>
                <xsl:when test="meta[@attribute = 'md4j:form-label-key']">
                    <xsl:value-of select="concat('     * @struts.validator-args arg0resource=&quot;', string(meta[@attribute = 'md4j:form-label-key'][1]), '&quot;&#10;')" />
                </xsl:when>
                <xsl:when test="meta[@attribute = 'md4j:form-label']">
                    <xsl:value-of select="concat('     * @struts.validator-args arg0value=&quot;', string(meta[@attribute = 'md4j:form-label'][1]), '&quot;&#10;')" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="concat('     * @struts.validator-args arg0resource=&quot;', $form.classname, '.', @name, '&quot;&#10;')" />
                </xsl:otherwise>
            </xsl:choose>
            
            <!--xsl:value-of select="concat('     *                   arg0key=&quot;', $form.classname, '.', @name, '&quot;&#10;')" /-->
        </xsl:if>
        <xsl:if test="$type = 'Date'">
            <xsl:variable name="datePattern">
                <xsl:choose>
                    <xsl:when test="string-length(meta[@attribute = 'md4j:date-format'][1]) &gt; 0">
                        <xsl:value-of select="meta[@attribute = 'md4j:date-format'][1]"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="'dd/MM/yyyy'"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>
            <xsl:value-of select="concat('     * @struts.validator-var name=&quot;datePattern&quot; value=&quot;', $datePattern, '&quot; &#10;')" />
        </xsl:if>
        <!-- TODO: add validator date pattern
            <meta attribute="md4j:date-format">MM/dd/yyyy</meta>    
        -->
        <xsl:text>     */&#10;</xsl:text>
        <xsl:value-of select="concat('    public void set', $beanMethodName, $suffix, '(', $type, ' ', @name, $suffix, '){&#10;')"/>
        <xsl:value-of select="concat('        this.', @name, $suffix, ' = ', @name, $suffix, ';&#10;')"/>
        <xsl:text>    }&#10;</xsl:text>
        
        <xsl:if test="$type = 'FormFile'">
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:text>     * Set the string representation ((partial?) path) of the form file, populated by logic in the generated Actions and stored in DB&#10;</xsl:text>
            <xsl:text>     */&#10;</xsl:text>
            <xsl:value-of select="concat('    public void set', $beanMethodName, '(', 'String', ' ', @name, '){&#10;')"/>
            <xsl:value-of select="concat('        this.', @name, ' = ', @name, ';&#10;')"/>
            <xsl:text>    }&#10;</xsl:text>
            
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:text>     * Get the string representation ((partial?) path) of the form file, populated by logic in the generated Actions and stored in DB&#10;</xsl:text>
            <xsl:text>     */&#10;</xsl:text>
            <xsl:value-of select="concat('    public String get', $beanMethodName, '(){&#10;')"/>
            <xsl:value-of select="concat('        return this.', @name, ';&#10;')"/>
            <xsl:text>    }&#10;</xsl:text>
        </xsl:if>
        
    </xsl:template>
    
    
    <xsl:template name="hbmtype.toValidatorType">
        <xsl:param name="hbmtype" />
        <xsl:choose>
            <xsl:when test="$hbmtype = 'integer' or $hbmtype = 'int' or $hbmtype = 'java.lang.Integer'">
                <xsl:text>integer</xsl:text>
            </xsl:when>
            <xsl:when test="$hbmtype = 'long' or $hbmtype = 'java.lang.Long'">
                <xsl:text>long</xsl:text>
            </xsl:when>
            <xsl:when test="$hbmtype = 'float' or $hbmtype = 'java.lang.Float'">
                <xsl:text>float</xsl:text>
            </xsl:when>
            <xsl:when test="$hbmtype = 'double' or $hbmtype = 'java.lang.Double' or $hbmtype = 'big_decimal'">
                <xsl:text>double</xsl:text>
            </xsl:when>
            <xsl:when test="$hbmtype = 'bool' or $hbmtype = 'boolean' or $hbmtype = 'yes_no' or $hbmtype = 'true_false'">
                <xsl:text>boolean</xsl:text>
            </xsl:when>
            <xsl:when test="$hbmtype = 'character' or $hbmtype = 'char'">
                <!-- TODO: use validator range -->
            </xsl:when>
            <xsl:when test="$hbmtype = 'date' or $hbmtype = 'time' or $hbmtype = 'timestamp' or $hbmtype = 'java.sql.Timestamp'">
                <xsl:text>date</xsl:text>
            </xsl:when>
            <xsl:when test="$hbmtype = 'calendar' or $hbmtype = 'calendar_date'">
                <xsl:text>date</xsl:text>
            </xsl:when>
            <!--xsl:when test="$type = 'locale'">
                <xsl:text>java.util.Locale</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'timezone'">
                <xsl:text>java.util.TimeZone</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'currency'">
                <xsl:text>java.util.Currency</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'class'">
                <xsl:text>Class</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'serializable'">
                <xsl:text>java.io.Serializable</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'binary'">
                <xsl:text>byte[]</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'clob'">
                <xsl:text>java.sql.Clob</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'blob'">
                <xsl:text>java.sql.Blob</xsl:text>
            </xsl:whene-->
        </xsl:choose>
    </xsl:template>
    
    <xsl:template name="fromMapToFormBeanProperty">
        <xsl:param name="formName" select="'this'" />
        <xsl:param name="mapName" select="'from'" />
        <xsl:param name="resolveRelations" select="'false'" />
        <xsl:param name="indentSpace" />
        <xsl:param name="typeOverride" />
        &propertyScopeVars;
        <xsl:variable name="javatypeOverride">
            <xsl:choose>
                <xsl:when test="string-length($typeOverride) > 0">
                    <xsl:value-of select="$typeOverride"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$javatype"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <!--xsl:value-of select="concat('/** fromObjectToFormBeanProperty: javatype is ', $javatype, ',hbmtype is ', $hbmtype, ', resolveRelations is ', $resolveRelations, '*/&#10;')"/-->
        <xsl:value-of select="concat($indentSpace, 'Object ', @name, 'Obj = from.get(&quot;', @name, '&quot;);&#10;')"/>
        <xsl:value-of select="concat($indentSpace, 'if(', @name, 'Obj != null){&#10;')"/>
        <xsl:choose>
            <xsl:when test="local-name() = 'many-to-one' or (local-name() = 'set' or local-name() = 'bag' or local-name() = 'list' or local-name() = 'array' or local-name() = 'set')">
                <xsl:if test="$resolveRelations = 'true' ">
                    <xsl:variable name="projection.suffix">
                        <xsl:choose>
                            <xsl:when test="meta[@attribute = 'md4j:project-property']">
                                <xsl:value-of select="meta[@attribute = 'md4j:project-property'][1]"/>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:call-template name="hbm2all:get.superclass.identifier">
                                    <xsl:with-param name="superclass"  select="$relatedClass"/>
                                </xsl:call-template>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:variable>
                    <xsl:value-of select="concat($indentSpace, '    ', $formName, '.', $setterName, '(', @name, 'Obj.toString());&#10;')"/>
                </xsl:if>
            </xsl:when>
            <xsl:when test="$javatypeOverride = 'String'">
                <xsl:value-of select="concat($indentSpace, '    ', $formName, '.', $setterName, '((String) ', @name, 'Obj);&#10;')"/>
            </xsl:when>
            <xsl:when test="$javatypeOverride = 'Boolean'">
                <xsl:value-of select="concat($indentSpace, '    ', $formName, '.', $setterName, '(', @name, 'Obj.toString());&#10;')"/>
            </xsl:when>
            <xsl:when test="$javatypeOverride = 'Date' or $javatypeOverride = 'java.util.Date'">
                <xsl:variable name="pattern">
                    <xsl:choose>
                        <xsl:when test="meta[@attribute = 'md4j:date-format']">
                            <xsl:value-of select="meta[@attribute = 'md4j:date-format']"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:text>MM/dd/yyyy</xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:variable>
                <xsl:value-of select="concat($indentSpace, '    ', $formName, '.', $setterName, '(new SimpleDateFormat(&quot;', $pattern, '&quot;).format((Date)', @name, 'Obj));&#10;')"/>
            </xsl:when>
            <!--xsl:when test="$javatype = 'FormFile'">
                <xsl:value-of select="concat('        File ',$name, ' = new File();&#10;')"/>
                <xsl:value-of select="concat('        FormFile ',$name, 'FormFile = ', $howtoget, ';&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setContentType(', $name, 'FormFile.getContentType());&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setFileSize(', $name, 'FormFile.getFileSize());&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setFileName(', $name, 'FormFile.getFileName());&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setInputStream(', $name, 'FormFile.getInputStream());&#10;')"/>
                </xsl:when-->
            <xsl:when test="$javatypeOverride = 'BigDecimal' or $javatypeOverride = 'BigInteger' or $javatypeOverride = 'Double' or $javatypeOverride = 'Float' or $javatypeOverride = 'Integer' or $javatypeOverride = 'Long' or $javatypeOverride = 'Short'">
                <xsl:value-of select="concat($indentSpace, '    ', $formName, '.', $setterName, '(', @name, 'Obj.toString());&#10;')"/>
            </xsl:when>
            
        </xsl:choose>
        <xsl:value-of select="concat($indentSpace, '}&#10;')"/>
    </xsl:template>
    
    <xsl:template name="fromObjectToFormBeanProperty">
        <xsl:param name="resolveRelations" select="'false'" />
        <xsl:param name="indentSpace" />
        <xsl:param name="formName" select="'this'"></xsl:param>
        <xsl:param name="typeOverride" />
        &propertyScopeVars;
        <xsl:variable name="javatypeOverride">
            <xsl:choose>
                <xsl:when test="string-length($typeOverride) > 0">
                    <xsl:value-of select="$typeOverride"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$javatype"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:choose>
            <xsl:when test="$resolveRelations = 'true' and local-name() = 'many-to-one' or (local-name() = 'set' or local-name() = 'bag' or local-name() = 'list' or local-name() = 'array' or local-name() = 'set')">
                <xsl:variable name="relatedObjectIdentifierGetter">
                    <xsl:call-template name="propertyName.toGetter">
                        <xsl:with-param name="propertyName">
                            <xsl:call-template name="hbm2all:get.superclass.identifier">
                                <xsl:with-param name="superclass"  select="$relatedClass"/>
                            </xsl:call-template>
                        </xsl:with-param>
                    </xsl:call-template>
                </xsl:variable>
                <xsl:value-of select="$indentSpace"/>
                <xsl:text>// Uncomment line below to copy from feched/non-lazy &#10;</xsl:text>
                <xsl:value-of select="concat($indentSpace, '// ', $formName, '.', $setterName, '(pojo.', $getterName,'().', $relatedObjectIdentifierGetter, '().toString());&#10;')"/>
            </xsl:when>
            <xsl:when test="$javatypeOverride = 'String'">
                <xsl:value-of select="concat($indentSpace, $formName, '.', $setterName, '(pojo.', $getterName,'());&#10;')"/>
            </xsl:when>
            <xsl:when test="$javatypeOverride = 'Boolean'">
                <xsl:value-of select="concat($indentSpace, $formName, '.', $setterName, '(pojo.', $getterName,'().toString());&#10;')"/>
            </xsl:when>
            <xsl:when test="$javatypeOverride = 'Date' or $javatypeOverride = 'java.util.Date'">
                <xsl:variable name="pattern">
                    <xsl:choose>
                        <xsl:when test="meta[@attribute = 'md4j:date-format']">
                            <xsl:value-of select="meta[@attribute = 'md4j:date-format']"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:text>MM/dd/yyyy</xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:variable>
                <xsl:value-of select="concat($indentSpace, $formName, '.', $setterName, '(new SimpleDateFormat(&quot;', $pattern, '&quot;).format(pojo.', $getterName,'()));&#10;')"/>
            </xsl:when>
            <!--xsl:when test="$javatype = 'FormFile'">
                <xsl:value-of select="concat('        File ',$name, ' = new File();&#10;')"/>
                <xsl:value-of select="concat('        FormFile ',$name, 'FormFile = ', $howtoget, ';&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setContentType(', $name, 'FormFile.getContentType());&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setFileSize(', $name, 'FormFile.getFileSize());&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setFileName(', $name, 'FormFile.getFileName());&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setInputStream(', $name, 'FormFile.getInputStream());&#10;')"/>
                </xsl:when-->
            <xsl:when test="$javatypeOverride = 'BigDecimal' or $javatypeOverride = 'BigInteger' or $javatypeOverride = 'Double' or $javatypeOverride = 'Float' or $javatypeOverride = 'Integer' or $javatypeOverride = 'Long'">
                <xsl:value-of select="concat($indentSpace, $formName, '.', $setterName, '(pojo.', $getterName,'().toString());&#10;')"/>
            </xsl:when>
            
        </xsl:choose>
    </xsl:template>
    
    
    <xsl:template name="getParentOptions" mode="getParentOptionsInRequest">
        <xsl:if test="@extends">
            <xsl:variable name="superclass" select="@extends"/>
            <xsl:for-each select="document(concat($superclass, '.hbm.xml'), .)/hibernate-mapping/*[@name = $superclass]">
                <xsl:call-template name="getParentOptions"/>
            </xsl:for-each>
        </xsl:if>
        <xsl:for-each select="many-to-one">
            <xsl:value-of select="concat('        String ', @name, 'Key = Md4jGlobals.PARENT_OPTIONS + &quot;#', @name, '&quot;;&#10;')"/>
            <xsl:value-of select="concat('        this.parentSelectOptions.put(', @name, 'Key, options.get(', @name, 'Key));&#10;')"/>
        </xsl:for-each>
    </xsl:template>
    
</xsl:transform>