<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE includes [
  <!ENTITY classScopeVars SYSTEM "classTemplateVars.inc">
  <!ENTITY getEJB SYSTEM "getEJB.inc">
  <!ENTITY getParams SYSTEM "getParams.xml">
  <!ENTITY propertyScopeVars SYSTEM "propertyScopeVars.inc">
  <!ENTITY licenseBlock SYSTEM "license.inc">
  ]>   
<!-- 
    /*
    * Copyright 2004-2005 Emmanouil Batsis
    * 
    * Licensed under the GNU General Public License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    * 
    *      http://www.gnu.org/licenses/gpl.txt
    * 
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * 
    */
-->
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
    xmlns:hbm2all="http://geekologue.com/ns/hbm4all/" xmlns:md4j="http://geekologue.com/md4j/">
    <xsl:output method="text" encoding="UTF-8" media-type="text/x-java-source"/>
    <xsl:include href="md4j-util.xsl"/>
    
    <xsl:template match="class|joined-subclass|subclass">
        <xsl:variable name="extends">
            <xsl:value-of select="'Action'"/>
            <!--xsl:choose>
                <xsl:when test="@extends">
                    <xsl:value-of select="concat(@extends, $actionType,  'Action')" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="'Action'"/>
                </xsl:otherwise>
            </xsl:choose-->
        </xsl:variable>
        &classScopeVars;
        <xsl:text>&licenseBlock;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:value-of select="concat('package ', $package, '.web;&#10;')"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import java.io.Serializable;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import java.util.HashMap;&#10;</xsl:text>
        <xsl:text>import java.util.Map;&#10;</xsl:text>
        <xsl:text>import java.util.Iterator;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import javax.servlet.http.HttpServletRequest;&#10;</xsl:text>
        <xsl:text>import javax.servlet.http.HttpServletResponse;&#10;</xsl:text>
        <xsl:text>import javax.servlet.http.HttpSession;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import org.apache.log4j.Logger;&#10;</xsl:text>
        <xsl:text>import org.apache.commons.lang.math.NumberUtils;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import org.apache.struts.action.ActionForm;&#10;</xsl:text>
        <xsl:text>import org.apache.struts.action.ActionForward;&#10;</xsl:text>
        <xsl:text>import org.apache.struts.action.ActionMessage;&#10;</xsl:text>
        <xsl:text>import org.apache.struts.action.ActionMessages;&#10;</xsl:text>
        <xsl:text>import org.apache.struts.action.ActionMapping;&#10;</xsl:text>
        <xsl:if test="property/meta[@attribute = 'md4j:is-file'][string(.) = 'true']">
            <xsl:text>import org.apache.struts.upload.FormFile;&#10;</xsl:text>
            <xsl:text>import org.apache.struts.upload.MultipartRequestHandler;&#10;</xsl:text>
        </xsl:if>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import org.apache.commons.beanutils.BeanUtils;&#10;</xsl:text>
        
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import javax.ejb.EJBException;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        
        <xsl:text>import gr.abiss.md4j.dto.File;&#10;</xsl:text>
        <xsl:text>import gr.abiss.md4j.business.BrokenConstraintsException;&#10;</xsl:text>
        <xsl:if test="$extends = 'Action'">
            <xsl:text>import org.apache.struts.action.Action;&#10;</xsl:text>
        </xsl:if>
        <xsl:text>import gr.abiss.md4j.util.StringUtil;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:value-of select="concat('import ', $package, '.web.', $form.classname, ';&#10;')"/>
        <xsl:value-of select="concat('import ', $package, '.business.', $ejb.classname, ';&#10;')"/>
        <xsl:value-of select="concat('import ', $package, '.business.', $ejb.util.classname, ';&#10;')"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>/**&#10;</xsl:text>
        <xsl:value-of select="concat(' * @struts.action path=&quot;', $action.path, '&quot; &#10;')"/>
        <xsl:value-of select="concat(' *                         name=&quot;', $form.classname, '&quot;&#10;')"/>
        <xsl:value-of select="concat(' *                         input=&quot;', $input.path, '&quot;&#10;')"/>
        <xsl:text> *                         scope="request"&#10;</xsl:text>
        <xsl:value-of select="concat(' *                         validate=&quot;', $validate, '&quot;&#10;')"/>
        <xsl:text> *&#10;</xsl:text>
        <!--xsl:value-of select="concat(' * @struts.action-forward path=&quot;', $input.path, '&quot;&#10;')"/>
            <xsl:text> *                         name="input" redirect="false"#10;</xsl:text-->
        <xsl:text> *&#10;</xsl:text>
        <!-- 
        Rediect back to loader action that will FW to View.jsp
         -->
        <xsl:value-of select="concat(' * @struts.action-forward path=&quot;', $view.path, '&quot;&#10;')"/>
        <xsl:value-of select="concat(' *                         name=&quot;', $action.classname, '&quot; redirect=&quot;true&quot;&#10;')"/>
        <xsl:text> *&#10;</xsl:text>
        <xsl:text> */&#10;</xsl:text>
        <xsl:value-of select="concat('public class ', $action.classname, ' extends ', $extends, '{&#10;')"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:value-of select="concat('    private static Logger log = Logger.getLogger(', $action.classname, '.class);&#10;')"/>
        
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:text>     * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)&#10;</xsl:text>
        <xsl:text>     */&#10;</xsl:text>
        <xsl:text>    public ActionForward execute(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) {&#10;</xsl:text>
        <xsl:text>        ActionForward fwd = null;&#10;</xsl:text>
        <xsl:text>        try{&#10;</xsl:text>
        
        <xsl:value-of select="concat('            ', $form.classname, ' form = (', $form.classname, ') actionForm;&#10;')"/>
        <xsl:choose>
            <xsl:when test="$actionType = 'Update' or id/generator/@type='assigned'">
                <xsl:value-of select="concat('            if(form.', $identifier.getter, '() == null){&#10;')" />
                <xsl:value-of select="concat('                throw new Exception(&quot;Could not find an identifier value using name: ', $identifier.name, '&quot;);&#10;')" />
                <xsl:text>            }&#10;</xsl:text>
            </xsl:when>
            <!--xsl:otherwise>
                <xsl:value-of select="concat('', '            Serializable identifier = null;&#10;')"/>
            </xsl:otherwise-->
        </xsl:choose>
        <xsl:text>            if(this.isTokenValid(request, true)) {&#10;</xsl:text>
        <!-- TODO: introduce business delegate -->
        <xsl:text>                </xsl:text>&getEJB;
        <xsl:text>                Map params = form.toMap();&#10;</xsl:text>
        // <xsl:value-of select="concat('md4j:on', translate($actionType, $uppercase, $lowercase), '-update-code-before-business', '&#10;')"/>
        <xsl:for-each select="meta[@attribute = 'md4j:oncreate-or-update-code-before-business' or @attribute = concat('md4j:on', translate($actionType, $uppercase, $lowercase), '-code-before-business')]">
            <xsl:value-of select="."/>
        </xsl:for-each>
        <xsl:choose>
            <xsl:when test="$actionType = 'Create'">
                <xsl:value-of select="concat('                form.', $identifier.setter, '(manager.save(params).toString());&#10;')" />
            </xsl:when>
            <xsl:when test="$actionType = 'Update'">
                <xsl:text>                manager.update(params);&#10;</xsl:text>
            </xsl:when>
            <xsl:otherwise>
                <xsl:message terminate="yes">Unknown Action type, expected Create or Update </xsl:message>
            </xsl:otherwise>
        </xsl:choose>
        <xsl:for-each select="meta[@attribute = 'md4j:oncreate-or-update-code-after-business' or @attribute = concat('md4j:on', translate($actionType, $uppercase, $lowercase), '-code-after-business')]">
            <xsl:value-of select="."/>
        </xsl:for-each>
        <xsl:value-of select="concat('                ActionForward basefw = mapping.findForward(&quot;', $action.classname, '&quot;);&#10;')"/>
        <xsl:value-of select="concat('                fwd = new ActionForward(basefw.getPath()+&quot;?', $identifier.name, '=&quot;+java.net.URLEncoder.encode(form.', $identifier.getter, '(), &quot;UTF-8&quot;), true);&#10;')" />
        <xsl:text>            }&#10;</xsl:text>
        <xsl:text>            // invalid token, try to redirect to view if identifier is available &#10;</xsl:text>
        <xsl:value-of select="concat('            else if(form.', $identifier.getter, '() != null){&#10;')" /> 
        <xsl:value-of select="concat('                ActionForward basefw = mapping.findForward(&quot;', $action.classname, '&quot;);&#10;')"/>
        <xsl:value-of select="concat('                fwd = new ActionForward(basefw.getPath()+&quot;?', $identifier.name, '=&quot;+java.net.URLEncoder.encode(form.', $identifier.getter, '(), &quot;UTF-8&quot;), true);&#10;')" />
        <xsl:text>            }&#10;</xsl:text>
        <xsl:text>            // if no identifier is available, save an error message and FW to error page &#10;</xsl:text>
        <xsl:text>            else {&#10;</xsl:text>
        <xsl:text>                ActionMessages messages = new ActionMessages();&#10;</xsl:text>
        <xsl:text>                messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("invalid input, probably taken value for unique field"));&#10;</xsl:text>
        <xsl:text>                this.addMessages(request, messages);&#10;</xsl:text>
        <xsl:text>            }&#10;</xsl:text>
        <xsl:text>        } &#10;</xsl:text>
        <xsl:text>        catch (EJBException e) {&#10;</xsl:text>
        <xsl:text>            // see if this is  a business validation caused exception, report as appropriate&#10;</xsl:text>
        <xsl:text>            Exception cause = e.getCausedByException();&#10;</xsl:text>
        <xsl:text>            if(cause.getClass().equals(BrokenConstraintsException.class)){&#10;</xsl:text>
        <xsl:text>                ActionMessages messages = new ActionMessages();&#10;</xsl:text>
        <xsl:text>                for(Iterator iter =  ((BrokenConstraintsException) cause).getViolated().iterator();iter.hasNext();){&#10;</xsl:text>
        <xsl:text>                    String key = (String) iter.next();&#10;</xsl:text>
        <xsl:text>                    // is this the right key?&#10;</xsl:text>
        <xsl:text>                    messages.add(key, new ActionMessage("errors.unique"));&#10;</xsl:text>
        <xsl:text>                    this.addMessages(request, messages);&#10;</xsl:text>
        <xsl:text>                }&#10;</xsl:text>
        <xsl:text>                fwd = mapping.getInputForward();&#10;</xsl:text>
        <xsl:text>            }&#10;</xsl:text>
        <xsl:text>        } catch (Exception e) {&#10;</xsl:text>
        <xsl:text>            throw new RuntimeException(e);&#10;</xsl:text>
        <xsl:text>        }&#10;</xsl:text>
        <xsl:text>        return fwd != null ? fwd : mapping.findForward("error");&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;}&#10;</xsl:text>
    </xsl:template>
</xsl:transform>
