<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE includes [
  <!ENTITY classScopeVars SYSTEM "classTemplateVars.inc">
  <!ENTITY propertyScopeVars SYSTEM "propertyScopeVars.inc">
  <!ENTITY getEJB SYSTEM "getEJB.inc">
  <!ENTITY licenseBlock SYSTEM "license.inc">
  ]>   
<!-- 
    /*
    * Copyright 2004-2005 Emmanouil Batsis
    * 
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    * 
    *      http://www.gnu.org/licenses/gpl.txt
    * 
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * 
    */
-->
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
    xmlns:hbm2all="http://geekologue.com/ns/hbm4all/" xmlns:md4j="http://geekologue.com/md4j/">
    <xsl:output method="text" encoding="UTF-8" media-type="text/x-java-source"/>
    
    <xsl:include href="md4j-util.xsl"/>
    
    
    <xsl:template name="class" match="class | joined-subclass | subclass">
        &classScopeVars;
        <xsl:text>&licenseBlock;</xsl:text>
        <xsl:text>&#10;</xsl:text>    
        <xsl:variable name="extends">
            <xsl:choose>
                <xsl:when test="@extends">
                    <xsl:value-of select="concat(@extends, $formType,  'Form')" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="'ValidatorForm'"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:value-of select="concat('package ', $package, '.web;&#10;')"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import java.util.Map;&#10;</xsl:text>
        <xsl:text>import java.util.HashMap;&#10;</xsl:text>
        <xsl:if test="$extends = 'ValidatorForm'">
            <xsl:text>import java.util.HashMap;&#10;</xsl:text>
            <xsl:text>&#10;</xsl:text>
            <xsl:text>import javax.servlet.http.HttpServletRequest;&#10;</xsl:text>
        </xsl:if>
        <xsl:if test="$formType != 'Search'">
            <xsl:text>import java.util.Date;&#10;</xsl:text>
            <xsl:text>&#10;</xsl:text>
            <xsl:text>import java.text.SimpleDateFormat;&#10;</xsl:text>
            <xsl:text>&#10;</xsl:text>
            <xsl:value-of select="concat('import ', $package, '.', $classname, ';&#10;')"/>
        </xsl:if>
        <xsl:if test="$extends = 'ValidatorForm'">
            <xsl:text>&#10;</xsl:text>
            <xsl:text>import org.apache.commons.lang.BooleanUtils;&#10;</xsl:text>
            <xsl:text>&#10;</xsl:text>
            <xsl:if test="property/meta[@attribute = 'md4j:is-file' and string(.) = 'true']">
                <xsl:text>import org.apache.struts.upload.FormFile;&#10;</xsl:text>
            </xsl:if>
            <xsl:text>import org.apache.struts.validator.ValidatorForm;&#10;</xsl:text>
            <xsl:text>import org.apache.struts.action.ActionErrors;&#10;</xsl:text>
            <xsl:text>import org.apache.struts.action.ActionMapping;&#10;</xsl:text>
        </xsl:if>
        <xsl:text>&#10;</xsl:text>
        <xsl:if test="$actionType = 'Search' and $extends = 'ValidatorForm'">
            <xsl:text>import gr.abiss.md4j.dao.Order;&#10;</xsl:text>
            <xsl:text>import gr.abiss.md4j.web.PagedSearchResultsForm;&#10;</xsl:text>
        </xsl:if>
        
        <xsl:text>import gr.abiss.md4j.util.Md4jGlobals;&#10;</xsl:text>
        
        
        <xsl:value-of select="concat('import ', $package,'.business.', $ejb.classname, ';&#10;')"/>
        <xsl:value-of select="concat('import ', $package, '.business.', $ejb.util.classname, ';&#10;')"/>
        
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import org.apache.log4j.Logger;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>/**&#10;</xsl:text>
        <xsl:value-of select="concat(' * @struts.form name=&quot;', $form.classname, '&quot;&#10;')"/>
        <xsl:text> *&#10;</xsl:text>
        <xsl:text> */&#10;</xsl:text>
        
        <xsl:choose>
            <xsl:when test="$formType = 'Search'">
                <xsl:choose>
                    <xsl:when test="$extends = 'ValidatorForm'">
                        <xsl:value-of select="concat('public class ', $form.classname, ' extends ', $extends, ' implements PagedSearchResultsForm{&#10;')"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="concat('public class ', $form.classname, ' extends ', $extends, ' {&#10;')"/>
                    </xsl:otherwise>
                </xsl:choose>
             </xsl:when>
            <xsl:when test="$formType = 'Crud'">
                <xsl:value-of select="concat('public class ', $form.classname, ' extends ', $extends,'{&#10;')"/>
            </xsl:when>
        </xsl:choose>
        <xsl:text>&#10;</xsl:text>
        <xsl:value-of select="concat('    private static Logger log = Logger.getLogger(', $form.classname, '.class);&#10;')"/>
        
        
        
        
        <!-- property declarations first -->
        <xsl:if test="$extends = 'ValidatorForm'">
            <xsl:text>&#10;</xsl:text>
            <xsl:text>    private Map parentSelectOptions = new HashMap();&#10;</xsl:text>
            <xsl:text>&#10;</xsl:text>
        </xsl:if>
        <xsl:if test="$formType = 'Search' and $extends = 'ValidatorForm'">
            <xsl:call-template name="property">
                <xsl:with-param name="form.classname" select="$form.classname" />
                <xsl:with-param name="name" select="'resultsPageNumber'" />
                <xsl:with-param name="defaultValue" select="null" />
                <xsl:with-param name="type" select="'Integer'" />
                <xsl:with-param name="struts.validator.type" select="'integer'" />
                </xsl:call-template>
            <xsl:value-of select="concat('    private String orderByPropertyName = &quot;', $identifier.name, '&quot;;&#10;')"/>
            <xsl:text>&#10;</xsl:text>
            <xsl:text>    private String orderByAscending = "true";&#10;</xsl:text>
        </xsl:if>
        <xsl:for-each select="id | property[not(@formula)] | many-to-one | set | bag | list | array | map">
            &propertyScopeVars;
            <!--xsl:value-of select="concat('               // before property call: ', local-name(), ' element&#10;')"/-->
            <xsl:choose>
                <xsl:when test="string-length($type) &gt; 0">
                    <xsl:call-template name="property">
                        <xsl:with-param name="form.classname" select="$form.classname" />
                        <xsl:with-param name="name" select="$name" />
                        <xsl:with-param name="type" select="$type" />
                    </xsl:call-template>
                </xsl:when>
            </xsl:choose>
        </xsl:for-each>
        <!-- getters setters -->
        <xsl:if test="$extends = 'ValidatorForm'">
            <xsl:text>&#10;</xsl:text>
            <xsl:text>    public Map getParentSelectOptions() {&#10;</xsl:text>
            <xsl:text>        return this.parentSelectOptions;&#10;</xsl:text>
            <xsl:text>    }&#10;</xsl:text>
            <xsl:text>&#10;</xsl:text>
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:text>     */&#10;</xsl:text> 
            <xsl:text>    public void setParentSelectOptions(Map options) {&#10;</xsl:text>
            <xsl:call-template name="getParentOptions" />
            <xsl:text>    }&#10;</xsl:text>
        </xsl:if>
        <xsl:if test="$actionType = 'Search' and $extends = 'ValidatorForm'">
            <xsl:text>&#10;</xsl:text>
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:text>     */&#10;</xsl:text> 
            <xsl:text>    public Order getOrder() {&#10;</xsl:text>
            <xsl:text>        return new Order().addOrder(this.orderByPropertyName, BooleanUtils.toBooleanDefaultIfNull(BooleanUtils.toBooleanObject(this.orderByAscending), Boolean.TRUE.booleanValue()));&#10;</xsl:text>
            <xsl:text>    }&#10;</xsl:text>
        </xsl:if>
        <xsl:text>&#10;</xsl:text>
        <xsl:for-each select="id | property[not(@formula)] | many-to-one | set | bag | list | array | map">
            &propertyScopeVars;
            <!--xsl:value-of select="concat('               // before propertyMethods call: ', local-name(), ' element&#10;')"/-->
            <xsl:variable name="struts.validator.type.required">
                <xsl:if test="not($actionType = 'Search') and 
                    ((not(local-name() = 'id') and (@not-null='true' or column/@not-null='true'))
                        or (local-name() = 'id' and generator[@class = 'assigned'])
                    )">
                    <xsl:text>required</xsl:text>
                </xsl:if>
            </xsl:variable>
            <xsl:variable name="struts.validator.type.type">
                <xsl:call-template name="hbmtype.toValidatorType">
                    <xsl:with-param name="hbmtype" select="$hbmtype"/>
                </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="struts.validator.type">
                <xsl:value-of select="$struts.validator.type.required" />
                <xsl:if test="string-length($struts.validator.type.required) &gt; 0 and string-length($struts.validator.type.type) &gt; 0">
                    <xsl:text>,</xsl:text>
                </xsl:if>
                <xsl:value-of select="$struts.validator.type.type"/>
            </xsl:variable> 
            <xsl:choose>
                <xsl:when test="string-length($type) &gt; 0">
                    <xsl:call-template name="propertyMethods">
                        <xsl:with-param name="form.classname" select="$form.classname" />
                        <xsl:with-param name="name" select="$name" />
                        <xsl:with-param name="type" select="$type" />
                        <xsl:with-param name="struts.validator.type" select="$struts.validator.type" />
                    </xsl:call-template>
                </xsl:when>
            </xsl:choose>
        </xsl:for-each>
        <xsl:if test="$formType = 'Search' and $extends = 'ValidatorForm'">
            <!-- maybe all this should go to an abstract search form or something -->
            <xsl:call-template name="propertyMethods">
                <xsl:with-param name="form.classname" select="$form.classname" />
                <xsl:with-param name="name" select="'resultsPageNumber'" />
                <xsl:with-param name="defaultValue" select="null" />
                <xsl:with-param name="type" select="'Integer'" />
                <xsl:with-param name="struts.validator.type" select="'integer'" />
            </xsl:call-template>        
            
            <xsl:call-template name="propertyMethods">
                <xsl:with-param name="form.classname" select="$form.classname" />
                <xsl:with-param name="name" select="'orderByPropertyName'" />
                <xsl:with-param name="defaultValue" select="concat('&quot;', $identifier.name, '&quot;')" />
                <xsl:with-param name="type" select="'String'" />
                <xsl:with-param name="struts.validator.type" select="'required'" />
            </xsl:call-template> 
            <xsl:call-template name="propertyMethods">
                <xsl:with-param name="form.classname" select="$form.classname" />
                <xsl:with-param name="name" select="'orderByAscending'" />
                <xsl:with-param name="defaultValue" select="concat('&quot;', $identifier.name, '&quot;')" />
                <xsl:with-param name="type" select="'String'" />
                <!--xsl:with-param name="struts.validator.type" select="'required,boolean'" /-->
                <xsl:with-param name="struts.validator.type" select="'required,boolean'" />
            </xsl:call-template>       
        </xsl:if>
        <xsl:if test="$formType != 'Search'">
            <xsl:text>&#10;</xsl:text>
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:text>     * Populate own properties from the given POJO&#10;</xsl:text>
            <xsl:text>     */&#10;</xsl:text>
            <xsl:text>    public void copyProperties(Object bean) {&#10;</xsl:text>
            <xsl:value-of select="concat('        ', $classname, ' pojo = (', $classname, ') bean;&#10;')"/>
            <xsl:if  test="not($extends = 'ValidatorForm' or $extends = 'ActionForm')">
                <xsl:text>        super.copyProperties(pojo);&#10;</xsl:text>
            </xsl:if>
            <xsl:for-each select="id | property[not(@formula)] | many-to-one | set | bag | list | array | map">
                <xsl:choose>
                    <xsl:when test="meta[@attribute = 'md4j:is-file'][1][string(.) = 'true']">
                        <xsl:call-template name="fromObjectToFormBeanProperty">
                            <xsl:with-param name="formName" select="'this'"/>
                            <xsl:with-param name="resolveRelations" select="'true'" />
                            <xsl:with-param name="indentSpace" select="'        '" />
                            <xsl:with-param name="typeOverride" select="'String'"/>
                        </xsl:call-template>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:call-template name="fromObjectToFormBeanProperty">
                            <xsl:with-param name="formName" select="'this'"/>
                            <xsl:with-param name="resolveRelations" select="'true'" />
                            <xsl:with-param name="indentSpace" select="'        '" />
                        </xsl:call-template>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:for-each>
            <xsl:text>    }&#10;</xsl:text>
            <xsl:text>&#10;</xsl:text>
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:text>     * Populate own properties from the given map&#10;</xsl:text>
            <!--xsl:text>   TODO:  * @see gr.abiss.md4j.web.Md4jActionForm#toMap()&#10;</xsl:text-->
            <xsl:text>     */&#10;</xsl:text> 
            <xsl:text>    public void copyProperties(Map from) {&#10;</xsl:text>
            <xsl:if  test="not($extends = 'ValidatorForm' or $extends = 'ActionForm')">
                <xsl:text>        super.copyProperties(from);&#10;</xsl:text>
            </xsl:if>
            <!--xsl:value-of select="concat('        ', $form.classname, ' form = (', $form.classname, ') actionForm;&#10;')"/-->
            
            <xsl:for-each select="id | property[not(@formula)] | many-to-one">
                <xsl:choose>
                    <!-- 
                        Object hashCodeObj = from.get("hashCode");
                        if(hashCodeObj != null){
                        this.setHashCode((String) hashCodeObj);
                        }
                    -->
                    <xsl:when test="meta[@attribute = 'md4j:is-file'][1][string(.) = 'true']">
                        <xsl:call-template name="fromMapToFormBeanProperty">
                            <xsl:with-param name="indentSpace" select="'        '"/>
                            <xsl:with-param name="formName" select="'this'"/>
                            <xsl:with-param name="mapName" select="'from'"/>
                            <xsl:with-param name="resolveRelations" select="'true'"/>
                            <xsl:with-param name="typeOverride" select="'String'"/>
                        </xsl:call-template>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:call-template name="fromMapToFormBeanProperty">
                            <xsl:with-param name="indentSpace" select="'        '"/>
                            <xsl:with-param name="formName" select="'this'"/>
                            <xsl:with-param name="mapName" select="'from'"/>
                            <xsl:with-param name="resolveRelations" select="'true'"/>
                        </xsl:call-template>
                    </xsl:otherwise>
                    
                </xsl:choose>
            </xsl:for-each>
            <xsl:text>    }&#10;</xsl:text>
        </xsl:if>
        <xsl:text>&#10;</xsl:text>
        
        
        
        <!-- Add the toMap method to retreive a HashMap of properties from the Form -->
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:text>     * Get the attribute vale pairs of this form bean instance as a Map&#10;</xsl:text>
        <xsl:text>     * @see gr.abiss.md4j.web.Md4jActionForm#toMap()&#10;</xsl:text>
        <xsl:text>     */&#10;</xsl:text> 
        <xsl:text>    public Map toMap() {&#10;</xsl:text>
        <xsl:choose>
            <xsl:when  test="$extends = 'ValidatorForm' or $extends = 'ActionForm'">
                <xsl:text>        Map params = new HashMap();&#10;</xsl:text>
            </xsl:when>
            <xsl:otherwise>
                <xsl:text>        Map params = super.toMap();&#10;</xsl:text>
            </xsl:otherwise>
        </xsl:choose>
        <!--xsl:value-of select="concat('        ', $form.classname, ' form = (', $form.classname, ') actionForm;&#10;')"/-->
        <xsl:for-each select="id | property[not(@formula)] | many-to-one | set | bag | list | array | map">
            &propertyScopeVars;
            <xsl:choose>
                <xsl:when test="string-length($searchType) &gt; 0">
                    <xsl:choose>
                        <!--xsl:when test="string(meta[@attribute = 'md4j:is-file'][1]) = 'true'">
                            
                        </xsl:when-->
                        <xsl:when test="$searchType = 'FormFile' or $searchType = 'String' or $searchType = 'Boolean' or $searchType = 'Date' or $searchType = 'java.math.BigDecimal' or $searchType = 'java.math.BigInteger' or $searchType = 'Double' or $searchType = 'Float' or $searchType = 'Integer' or $searchType = 'Long' or $searchType = 'Short'">
                            <!--xsl:if test="$formType = 'Search'"-->
                            <xsl:value-of select="concat('        if(this.', @name, ' != null &amp;&amp; this.', @name, '.length() > 0){&#10;')"/>
                            <xsl:value-of select="concat('            params.put(&quot;', @name, '&quot;, this.', @name, ');&#10;')"/>
                            <xsl:text>        }&#10;</xsl:text>
                            <!--/xsl:if-->
                        </xsl:when>
                        <!--xsl:when test="$searchType = 'FormFile'">
                            <xsl:value-of select="concat('        File ',@name, ' = new File();&#10;')"/>
                            <xsl:value-of select="concat('        FormFile ',@name, 'FormFile = this.', $getterName, '();&#10;')"/>
                            <xsl:value-of select="concat('        ',@name, '.setContentType(', @name, 'FormFile.getContentType());&#10;')"/>
                            <xsl:value-of select="concat('        ',@name, '.setFileSize(', @name, 'FormFile.getFileSize());&#10;')"/>
                            <xsl:value-of select="concat('        ',@name, '.setFileName(', @name, 'FormFile.getFileName());&#10;')"/>
                            <xsl:value-of select="concat('        ',@name, '.setInputStream(', @name, 'FormFile.getInputStream());&#10;')"/>
                            <xsl:value-of select="concat('        params.put(&quot;', @name, '&quot;, ', @name, ');&#10;')"/>
                        </xsl:when-->
                        <xsl:otherwise>
                            <xsl:value-of select="concat('/**            Could not add ', $searchType , '!!!!*/&#10;')" />
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:when>
            </xsl:choose>
        </xsl:for-each>
        <xsl:text>        return params;&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        
        <xsl:if test="$extends = 'ValidatorForm'">
            <xsl:text>&#10;</xsl:text>
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:text>     * Intercept the validatation call to reload options that are needed for the (X)HTML form in case validation fails.&#10;</xsl:text>
            <xsl:text>     * @see org.apache.struts.validator.ValidatorForm#validate(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)&#10;</xsl:text>
            <xsl:text>     */&#10;</xsl:text>
            <xsl:text>    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {&#10;</xsl:text>
            <xsl:text>        ActionErrors errors = super.validate(mapping, request);&#10;</xsl:text>
            <xsl:text>        if(errors != null &amp;&amp; !errors.isEmpty()){&#10;</xsl:text>
            <xsl:text>            try{&#10;</xsl:text>
            <xsl:text>                </xsl:text>&getEJB;
            <xsl:text>                this.setParentSelectOptions(manager.getParentOptions());&#10;</xsl:text>
            <xsl:text>            }&#10;</xsl:text>
            <xsl:text>            catch(Exception e){&#10;</xsl:text>
            <xsl:text>                log.error(e);&#10;</xsl:text>
            <xsl:text>            }&#10;</xsl:text>
            <xsl:text>        }&#10;</xsl:text>
            <xsl:text>        return errors;&#10;</xsl:text>
            <xsl:text>    }&#10;</xsl:text>
        </xsl:if>
        
        <xsl:text>&#10;}&#10;</xsl:text>
    </xsl:template>
    
    
    <xsl:template name="property" mode="property">
        <xsl:param name="name" />
        <xsl:param name="type" select="'String'" />
        <xsl:param name="description" select="''" />
        <xsl:param name="defaultValue" select="''" />
        
        <!--xsl:value-of select="concat('               // property: ', local-name(), ' element&#10;')"/-->
        <xsl:variable name="assignment">
            <xsl:if test="string-length($defaultValue) &gt; 0">
                <xsl:value-of select="concat(' = ', $defaultValue)"/>
            </xsl:if>
        </xsl:variable>
        <xsl:variable name="propertyDescription">
            <xsl:choose>
                <xsl:when test="string-length($description) &gt; 0">
                    <xsl:value-of select="$description"/>
                </xsl:when>    
                <xsl:otherwise>
                    <xsl:value-of select="@name"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:choose>
            <xsl:when test="$type = 'FormFile'">
                <xsl:text>&#10;</xsl:text>
                <xsl:text>    /**&#10;</xsl:text>
                <xsl:value-of select="concat('     * ', $propertyDescription, ' FormFile &#10;')" />
                <xsl:text>     */&#10;</xsl:text>
                <xsl:value-of select="concat('    private ', $type, ' ', $name, 'FormFile', $assignment, ';&#10;')"/>
                <xsl:text>&#10;</xsl:text>
                <xsl:text>    /**&#10;</xsl:text>
                <xsl:value-of select="concat('     * ', $propertyDescription, '&#10;')" />
                <xsl:text>     */&#10;</xsl:text>
                <xsl:value-of select="concat('    private ', 'String', ' ', $name, $assignment, ';&#10;')"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:text>&#10;</xsl:text>
                <xsl:text>    /**&#10;</xsl:text>
                <xsl:value-of select="concat('     * ', $propertyDescription, '&#10;')" />
                <xsl:text>     */&#10;</xsl:text>
                <xsl:value-of select="concat('    private ', $type, ' ', $name, $assignment, ';&#10;')"/>
            </xsl:otherwise>
        </xsl:choose>
        
    </xsl:template>
    
    <xsl:template name="propertyMethods" mode="propertyMethods">
        <xsl:param name="form.classname" />
        <xsl:param name="name" />
		<xsl:param name="struts.validator.type" />
		<xsl:param name="type" select="'String'" />
        
        <!--xsl:value-of select="concat('               // propertyMethods: ', local-name(), ' element&#10;')"/-->
		<xsl:variable name="beanMethodName">
		    <xsl:call-template name="hbm2all:string.toUpperCamel">
		        <xsl:with-param name="string" select="$name" />
		    </xsl:call-template>
		</xsl:variable>
        <xsl:variable name="suffix">
            <xsl:if test="$type = 'FormFile'">
                <xsl:value-of select="'FormFile'"/>
            </xsl:if>
        </xsl:variable>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:value-of select="concat('     * Get the ', $name, $suffix, '&#10;')"/>
        <xsl:value-of select="concat('     * @return the ', $name, $suffix, '&#10;')"/>
		<xsl:text>     */&#10;</xsl:text>
        <xsl:value-of select="concat('    public ', $type, ' get', $beanMethodName,  $suffix, '(){&#10;')"/>
        <xsl:value-of select="concat('        return this.', $name, $suffix, ';&#10;')"/>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
		<xsl:text>    /**&#10;</xsl:text>
        <xsl:value-of select="concat('     * Set the ', $name, $suffix, '&#10;')"/>
        <xsl:if test="string-length($struts.validator.type) &gt; 0">
            <xsl:value-of select="concat('     * @param ', $name, ' the ', $name, $suffix, ' to set&#10;')"/>
            <xsl:choose>
                <xsl:when test="contains($struts.validator.type, 'boolean')">
                    <!-- emulate boolean by enforcing either 0 or 1 -->
                    <xsl:text>     * @struts.validator type=&quot;</xsl:text>
                    <xsl:if test="contains($struts.validator.type, 'required')">
                        <xsl:text>required,</xsl:text>
                    </xsl:if>
                    <xsl:text>validwhen</xsl:text>
                    <xsl:text>&quot; msgkey=&quot;boolean&quot;&#10;</xsl:text>
                    <xsl:choose>
                        <xsl:when test="$actionType = 'Search'">
                            <xsl:text>     * @struts.validator-var name=&quot;test&quot; value=&quot;((*this* == null) or ((*this* == 'true') or (*this* == 'false')))&quot;&#10;</xsl:text>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:text>     * @struts.validator-var name=&quot;test&quot; value=&quot;((*this* == 'true') or (*this* == 'false'))&quot;&#10;</xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="concat('     * @struts.validator type=&quot;', $struts.validator.type, '&quot;&#10;')" />
                </xsl:otherwise>
            </xsl:choose>
            <xsl:choose>
                <xsl:when test="meta[@attribute = 'md4j:form-label-key']">
                    <xsl:value-of select="concat('     * @struts.validator-args arg0resource=&quot;', string(meta[@attribute = 'md4j:form-label-key'][1]), '&quot;&#10;')" />
                </xsl:when>
                <xsl:when test="meta[@attribute = 'md4j:form-label']">
                    <xsl:value-of select="concat('     * @struts.validator-args arg0value=&quot;', string(meta[@attribute = 'md4j:form-label'][1]), '&quot;&#10;')" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="concat('     * @struts.validator-args arg0resource=&quot;', $form.classname, '.', @name, '&quot;&#10;')" />
                </xsl:otherwise>
            </xsl:choose>
            
            <!--xsl:value-of select="concat('     *                   arg0key=&quot;', $form.classname, '.', @name, '&quot;&#10;')" /-->
        </xsl:if>
        <xsl:if test="$type = 'Date'">
            <xsl:variable name="datePattern">
                <xsl:choose>
                    <xsl:when test="string-length(meta[@attribute = 'md4j:date-format'][1]) &gt; 0">
                        <xsl:value-of select="meta[@attribute = 'md4j:date-format'][1]"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="'dd/MM/yyyy'"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>
            <xsl:value-of select="concat('     * @struts.validator-var name=&quot;datePattern&quot; value=&quot;', $datePattern, '&quot; &#10;')" />
        </xsl:if>
        <!-- TODO: add validator date pattern
            <meta attribute="md4j:date-format">MM/dd/yyyy</meta>    
         -->
		<xsl:text>     */&#10;</xsl:text>
        <xsl:value-of select="concat('    public void set', $beanMethodName, $suffix, '(', $type, ' ', $name, $suffix, '){&#10;')"/>
        <xsl:value-of select="concat('        this.', $name, $suffix, ' = ', $name, $suffix, ';&#10;')"/>
        <xsl:text>    }&#10;</xsl:text>
        
        <xsl:if test="$type = 'FormFile'">
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:text>     * Set the string representation ((partial?) path) of the form file, populated by logic in the generated Actions and stored in DB&#10;</xsl:text>
            <xsl:text>     */&#10;</xsl:text>
            <xsl:value-of select="concat('    public void set', $beanMethodName, '(', 'String', ' ', $name, '){&#10;')"/>
            <xsl:value-of select="concat('        this.', $name, ' = ', $name, ';&#10;')"/>
            <xsl:text>    }&#10;</xsl:text>
            
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:text>     * Get the string representation ((partial?) path) of the form file, populated by logic in the generated Actions and stored in DB&#10;</xsl:text>
            <xsl:text>     */&#10;</xsl:text>
            <xsl:value-of select="concat('    public String get', $beanMethodName, '(){&#10;')"/>
            <xsl:value-of select="concat('        return this.', $name, ';&#10;')"/>
            <xsl:text>    }&#10;</xsl:text>
        </xsl:if>
        
    </xsl:template>
    
    
    <xsl:template name="hbmtype.toValidatorType">
        <xsl:param name="hbmtype" />
        <xsl:choose>
            <xsl:when test="$hbmtype = 'integer' or $hbmtype = 'int' or $hbmtype = 'java.lang.Integer'">
                <xsl:text>integer</xsl:text>
            </xsl:when>
            <xsl:when test="$hbmtype = 'long' or $hbmtype = 'java.lang.Long'">
                <xsl:text>long</xsl:text>
            </xsl:when>
            <xsl:when test="$hbmtype = 'float' or $hbmtype = 'java.lang.Float'">
                <xsl:text>float</xsl:text>
            </xsl:when>
            <xsl:when test="$hbmtype = 'double' or $hbmtype = 'java.lang.Double' or $hbmtype = 'big_decimal'">
                <xsl:text>double</xsl:text>
            </xsl:when>
            <xsl:when test="$hbmtype = 'bool' or $hbmtype = 'boolean' or $hbmtype = 'yes_no' or $hbmtype = 'true_false'">
                <xsl:text>boolean</xsl:text>
            </xsl:when>
            <xsl:when test="$hbmtype = 'character' or $hbmtype = 'char'">
                <!-- TODO: use validator range -->
            </xsl:when>
            <xsl:when test="$hbmtype = 'date' or $hbmtype = 'time' or $hbmtype = 'timestamp' or $hbmtype = 'java.sql.Timestamp'">
                <xsl:text>date</xsl:text>
            </xsl:when>
            <xsl:when test="$hbmtype = 'calendar' or $hbmtype = 'calendar_date'">
                <xsl:text>date</xsl:text>
            </xsl:when>
            <!--xsl:when test="$type = 'locale'">
                <xsl:text>java.util.Locale</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'timezone'">
                <xsl:text>java.util.TimeZone</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'currency'">
                <xsl:text>java.util.Currency</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'class'">
                <xsl:text>Class</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'serializable'">
                <xsl:text>java.io.Serializable</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'binary'">
                <xsl:text>byte[]</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'clob'">
                <xsl:text>java.sql.Clob</xsl:text>
            </xsl:when>
            <xsl:when test="$type = 'blob'">
                <xsl:text>java.sql.Blob</xsl:text>
            </xsl:whene-->
        </xsl:choose>
    </xsl:template>
    
    <xsl:template name="fromMapToFormBeanProperty">
        <xsl:param name="formName" select="'this'" />
        <xsl:param name="mapName" select="'from'" />
        <xsl:param name="resolveRelations" select="'false'" />
        <xsl:param name="indentSpace" />
        <xsl:param name="typeOverride" />
        &propertyScopeVars;
        <xsl:variable name="javatypeOverride">
            <xsl:choose>
                <xsl:when test="string-length($typeOverride) > 0">
                    <xsl:value-of select="$typeOverride"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$javatype"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <!--xsl:value-of select="concat('/** fromObjectToFormBeanProperty: javatype is ', $javatype, ',hbmtype is ', $hbmtype, ', resolveRelations is ', $resolveRelations, '*/&#10;')"/-->
        <xsl:value-of select="concat($indentSpace, 'Object ', @name, 'Obj = from.get(&quot;', @name, '&quot;);&#10;')"/>
        <xsl:value-of select="concat($indentSpace, 'if(', @name, 'Obj != null){&#10;')"/>
        <xsl:choose>
            <xsl:when test="local-name() = 'many-to-one' or (local-name() = 'set' or local-name() = 'bag' or local-name() = 'list' or local-name() = 'array' or local-name() = 'set')">
                <xsl:if test="$resolveRelations = 'true' ">
                    <xsl:variable name="projection.suffix">
                        <xsl:choose>
                            <xsl:when test="meta[@attribute = 'md4j:project-property']">
                                <xsl:value-of select="meta[@attribute = 'md4j:project-property'][1]"/>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:call-template name="hbm2all:get.superclass.identifier">
                                    <xsl:with-param name="superclass"  select="$relatedClass"/>
                                </xsl:call-template>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:variable>
                    <xsl:value-of select="concat($indentSpace, '    ', $formName, '.', $setterName, '(', @name, 'Obj.toString());&#10;')"/>
                </xsl:if>
            </xsl:when>
            <xsl:when test="$javatypeOverride = 'String'">
                <xsl:value-of select="concat($indentSpace, '    ', $formName, '.', $setterName, '((String) ', @name, 'Obj);&#10;')"/>
            </xsl:when>
            <xsl:when test="$javatypeOverride = 'Boolean'">
                <xsl:value-of select="concat($indentSpace, '    ', $formName, '.', $setterName, '(', @name, 'Obj.toString());&#10;')"/>
            </xsl:when>
            <xsl:when test="$javatypeOverride = 'Date' or $javatypeOverride = 'java.util.Date'">
                <xsl:variable name="pattern">
                    <xsl:choose>
                        <xsl:when test="meta[@attribute = 'md4j:date-format']">
                            <xsl:value-of select="meta[@attribute = 'md4j:date-format']"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:text>MM/dd/yyyy</xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:variable>
                <xsl:value-of select="concat($indentSpace, '    ', $formName, '.', $setterName, '(new SimpleDateFormat(&quot;', $pattern, '&quot;).format((Date)', @name, 'Obj));&#10;')"/>
            </xsl:when>
            <!--xsl:when test="$javatype = 'FormFile'">
                <xsl:value-of select="concat('        File ',$name, ' = new File();&#10;')"/>
                <xsl:value-of select="concat('        FormFile ',$name, 'FormFile = ', $howtoget, ';&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setContentType(', $name, 'FormFile.getContentType());&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setFileSize(', $name, 'FormFile.getFileSize());&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setFileName(', $name, 'FormFile.getFileName());&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setInputStream(', $name, 'FormFile.getInputStream());&#10;')"/>
                </xsl:when-->
            <xsl:when test="$javatypeOverride = 'BigDecimal' or $javatypeOverride = 'BigInteger' or $javatypeOverride = 'Double' or $javatypeOverride = 'Float' or $javatypeOverride = 'Integer' or $javatypeOverride = 'Long' or $javatypeOverride = 'Short'">
                <xsl:value-of select="concat($indentSpace, '    ', $formName, '.', $setterName, '(', @name, 'Obj.toString());&#10;')"/>
            </xsl:when>
            
        </xsl:choose>
        <xsl:value-of select="concat($indentSpace, '}&#10;')"/>
    </xsl:template>
    
    <xsl:template name="fromObjectToFormBeanProperty">
        <xsl:param name="resolveRelations" select="'false'" />
        <xsl:param name="indentSpace" />
        <xsl:param name="formName" select="'this'"></xsl:param>
        <xsl:param name="typeOverride" />
        &propertyScopeVars;
        <xsl:variable name="javatypeOverride">
            <xsl:choose>
                <xsl:when test="string-length($typeOverride) > 0">
                    <xsl:value-of select="$typeOverride"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$javatype"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:choose>
            <xsl:when test="$resolveRelations = 'true' and local-name() = 'many-to-one' or (local-name() = 'set' or local-name() = 'bag' or local-name() = 'list' or local-name() = 'array' or local-name() = 'set')">
                <xsl:variable name="relatedObjectIdentifierGetter">
                    <xsl:call-template name="propertyName.toGetter">
                        <xsl:with-param name="propertyName">
                            <xsl:call-template name="hbm2all:get.superclass.identifier">
                                <xsl:with-param name="superclass"  select="$relatedClass"/>
                            </xsl:call-template>
                        </xsl:with-param>
                    </xsl:call-template>
                </xsl:variable>
                <xsl:value-of select="$indentSpace"/>
                <xsl:text>// Uncomment line below to copy from feched/non-lazy &#10;</xsl:text>
                <xsl:value-of select="concat($indentSpace, '// ', $formName, '.', $setterName, '(pojo.', $getterName,'().', $relatedObjectIdentifierGetter, '().toString());&#10;')"/>
            </xsl:when>
            <xsl:when test="$javatypeOverride = 'String'">
                <xsl:value-of select="concat($indentSpace, $formName, '.', $setterName, '(pojo.', $getterName,'());&#10;')"/>
            </xsl:when>
            <xsl:when test="$javatypeOverride = 'Boolean'">
                <xsl:value-of select="concat($indentSpace, $formName, '.', $setterName, '(pojo.', $getterName,'().toString());&#10;')"/>
            </xsl:when>
            <xsl:when test="$javatypeOverride = 'Date' or $javatypeOverride = 'java.util.Date'">
                <xsl:variable name="pattern">
                    <xsl:choose>
                        <xsl:when test="meta[@attribute = 'md4j:date-format']">
                            <xsl:value-of select="meta[@attribute = 'md4j:date-format']"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:text>MM/dd/yyyy</xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:variable>
                <xsl:value-of select="concat($indentSpace, $formName, '.', $setterName, '(new SimpleDateFormat(&quot;', $pattern, '&quot;).format(pojo.', $getterName,'()));&#10;')"/>
            </xsl:when>
            <!--xsl:when test="$javatype = 'FormFile'">
                <xsl:value-of select="concat('        File ',$name, ' = new File();&#10;')"/>
                <xsl:value-of select="concat('        FormFile ',$name, 'FormFile = ', $howtoget, ';&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setContentType(', $name, 'FormFile.getContentType());&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setFileSize(', $name, 'FormFile.getFileSize());&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setFileName(', $name, 'FormFile.getFileName());&#10;')"/>
                <xsl:value-of select="concat('        ',$name, '.setInputStream(', $name, 'FormFile.getInputStream());&#10;')"/>
                </xsl:when-->
            <xsl:when test="$javatypeOverride = 'BigDecimal' or $javatypeOverride = 'BigInteger' or $javatypeOverride = 'Double' or $javatypeOverride = 'Float' or $javatypeOverride = 'Integer' or $javatypeOverride = 'Long'">
                <xsl:value-of select="concat($indentSpace, $formName, '.', $setterName, '(pojo.', $getterName,'().toString());&#10;')"/>
            </xsl:when>
            
        </xsl:choose>
    </xsl:template>
    
    
    <xsl:template name="getParentOptions" mode="getParentOptionsInRequest">
        <xsl:if test="@extends">
            <xsl:variable name="superclass" select="@extends"/>
            <xsl:for-each select="document(concat($superclass, '.hbm.xml'), .)/hibernate-mapping/*[@name = $superclass]">
                <xsl:call-template name="getParentOptions"/>
            </xsl:for-each>
        </xsl:if>
        <xsl:for-each select="many-to-one">
            <xsl:value-of select="concat('        String ', @name, 'Key = Md4jGlobals.PARENT_OPTIONS + &quot;#', @name, '&quot;;&#10;')"/>
            <xsl:value-of select="concat('        this.parentSelectOptions.put(', @name, 'Key, options.get(', @name, 'Key));&#10;')"/>
        </xsl:for-each>
    </xsl:template>
    
</xsl:transform>