<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE includes [
  <!ENTITY classScopeVars SYSTEM "classTemplateVars.inc">
  <!ENTITY propertyScopeVars SYSTEM "propertyScopeVars.inc">
  <!ENTITY getParams SYSTEM "getParams.xml">
  <!ENTITY licenseBlock SYSTEM "license.inc">
  ]>
<!-- 
   /*
    * Copyright 2004-2005 Emmanouil Batsis
    * 
    * Licensed under the GNU General Public License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    * 
    *      http://www.gnu.org/licenses/gpl.txt
    * 
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * 
    */
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xalan="http://xml.apache.org/xalan" 
    xmlns:hbm2all="http://geekologue.com/ns/hbm4all/" 
    xmlns:md4j="http://geekologue.com/md4j/" 
    xmlns:jsp="http://java.sun.com/JSP/Page" 
    xmlns:bean="http://struts.apache.org/tags-bean" 
    xmlns:html="http://struts.apache.org/tags-html" 
    xmlns:logic="http://struts.apache.org/tags-logic"
    xmlns:c="http://java.sun.com/jsp/jstl/core" 
    exclude-result-prefixes="hbm2all md4j xalan">
    
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4"  encoding="UTF-8" media-type="text/x-java-source" />
    
    <xsl:include href="md4j-util.xsl"/>
    
    <xsl:variable name="dollar" select="'$'"/>
    <xsl:variable name="lbrace" select="'{'"/>
    <xsl:variable name="rbrace" select="'}'"/>
    
    <xsl:template name="class" match="class|joined-subclass|subclass">
        <xsl:variable name="action" select="translate($actionType, $uppercase, $lowercase)" />
        <xsl:comment>
            <xsl:text>&licenseBlock;</xsl:text>
        </xsl:comment>
        &classScopeVars;
        <jsp:root version="2.0">
            <jsp:directive.page 
                language="java"
                contentType="text/html; charset=UTF-8" 
                pageEncoding="UTF-8" 
                import="{$full.classname}" 
                isELIgnored="false" />
            <jsp:output
                omit-xml-declaration="false"
                doctype-root-element="html"
                doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN"
                doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"/>
            
            <!-- store page title on pageContext.windowTitle -->
            <bean:define id="windowTitle" toScope="page" type="java.lang.String">
                <!--bean:message key="{concat($full.classname, '.', $actionType, '.windowTitle')}" /-->
                <bean:message key="{$action}" />
                <xsl:text>: &#10;</xsl:text>
                <bean:message key="{translate($classname, $uppercase, $lowercase)}" />
            </bean:define>
            <jsp:directive.include file="../md4j-dep/header.inc" />
            <html:xhtml />
            <xsl:if test="not($actionType = 'View')">   
                <script type="text/javascript" src="../md4j-dep/validator-static-js.jsp"><jsp:text><xsl:text> </xsl:text></jsp:text></script>
                <html:javascript formName="{$form.classname}" staticJavascript="false" />
            </xsl:if>
            <xsl:if test="$actionType = 'View' and //meta[@attribute = 'md4j:render-as-image']">
                <script type="text/javascript" src="{concat($dollar, $lbrace)}pageContext.request.contextPath{$rbrace}/js/prototype.js"><jsp:text><xsl:text> </xsl:text></jsp:text></script>
                <script type="text/javascript" src="{concat($dollar, $lbrace)}pageContext.request.contextPath{$rbrace}/js/scriptaculous.js?load=effects"><jsp:text><xsl:text> </xsl:text></jsp:text></script>
                <script type="text/javascript" src="{concat($dollar, $lbrace)}pageContext.request.contextPath{$rbrace}/js/lightbox.js"><jsp:text><xsl:text> </xsl:text></jsp:text></script>
            </xsl:if>
            <!-- TODO: check if date-ish properties exist here or in parent -->
            <xsl:if test="//property[@type = 'date' or @type = 'time' or @type = 'timestamp' or @type = 'java.sql.Timestamp' or @type = 'java.sql.Date' or @type = 'java.util.Date']">
                <!-- calendar stylesheet -->
                <link rel="stylesheet" type="text/css" media="all" href="{concat($dollar, $lbrace)}pageContext.request.contextPath{$rbrace}/md4j-dep/jscalendar/calendar-system.css" title="jscalendar system CSS theme" />
                <!-- main calendar program -->
                <script type="text/javascript" src="{concat($dollar, $lbrace)}pageContext.request.contextPath{$rbrace}/md4j-dep/jscalendar/calendar.js"><jsp:text><xsl:text> </xsl:text></jsp:text></script>
                <!-- language for the calendar -->
                <script type="text/javascript" src="{concat($dollar, $lbrace)}pageContext.request.contextPath{$rbrace}/md4j-dep/jscalendar/lang/calendar-en.js"><jsp:text><xsl:text> </xsl:text></jsp:text></script>
                <!-- the following script defines the Calendar.setup helper function, which makes
                    adding a calendar a matter of 1 or 2 lines of code. -->
                <script type="text/javascript" src="{concat($dollar, $lbrace)}pageContext.request.contextPath{$rbrace}/md4j-dep/jscalendar/calendar-setup.js"><jsp:text><xsl:text> </xsl:text></jsp:text></script>
            </xsl:if>
            <logic:messagesPresent message="true">
                <ul class="user-messages">
                    <html:messages id="msg" message="true">
                        <li class="user-message">
                            <bean:write name="msg" />
                        </li>
                    </html:messages>
                </ul>
            </logic:messagesPresent>
            
            <xsl:comment><xsl:value-of select="concat('// actionLowcase:', $actionLowcase)"/> </xsl:comment>
            <!-- TODO: header and heading elements here -->
            <!--td><input type="text" name="senderName" class="grey" readonly="readonly" value="${identity.user.name}" size="50" /></td-->
            <xsl:choose>
                <xsl:when test="$actionType = 'View'">
                    <div id="md4jSection">
                        <h3>
                            <bean:message key="{$action}" />
                            <xsl:text>: &#10;</xsl:text>
                            <bean:message key="{translate($classname, $uppercase, $lowercase)}" />
                        </h3>
                        <div id="md4jFormOrViewWrapper">
                            <div styleClass="md4jFormOrView">
                                <fieldset>
                                    <legend>
                                        <bean:message key="legent.info" />
                                        <bean:message key="{translate($classname, $uppercase, $lowercase)}" />
                                    </legend>
                                    <xsl:call-template name="renderFormBeanPropertiesAsView">
                                        <xsl:with-param name="action" select="$actionType"/>
                                        <xsl:with-param name="actionLowcase" select="$actionLowcase"/>
                                        <xsl:with-param name="form.classname" select="$form.classname" />
                                        <xsl:with-param name="skipFiles" select="'true'" />
                                    </xsl:call-template>
                                </fieldset>
                                <!--fieldset>
                                    <legend>
                                        <bean:message key="{$action}.legend.files" />
                                    </legend>
                                    <xsl:call-template name="renderFormBeanPropertiesAsView">
                                        <xsl:with-param name="action" select="$actionType"/>
                                        <xsl:with-param name="form.classname" select="$form.classname" />
                                        <xsl:with-param name="skipFiles" select="'false'" />
                                    </xsl:call-template>
                                </fieldset-->
                            </div>
                        </div>
                    </div>
                </xsl:when>
                <xsl:otherwise>
                    <div id="md4jSection">
                        <h3>
                            <bean:message key="{$action}" />
                            <xsl:text>: &#10;</xsl:text>
                            <bean:message key="{translate($classname, $uppercase, $lowercase)}" />
                        </h3>
                        <div id="md4jFormOrViewWrapper">
                            <html:form acceptCharset="UTF-8" styleClass="md4jFormOrView" action="{$action.path}" onsubmit="return validate{$form.classname}(this);">
                                <xsl:choose>
                                    <xsl:when test="$actionType = 'Create' or $actionType = 'Update'">
                                        <xsl:attribute name="method">post</xsl:attribute>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:attribute name="method">get</xsl:attribute>
                                    </xsl:otherwise>
                                </xsl:choose>
                                <xsl:if test="($actionType = 'Create' or $actionType = 'Update') and property/meta[@attribute = 'md4j:is-file'][string(.) = 'true']">
                                    <xsl:attribute name="enctype">multipart/form-data</xsl:attribute>
                                </xsl:if>
                                <fieldset>
                                    <legend>
                                        <bean:message key="{$action}.legend.criteria" />
                                    </legend>
                                    <xsl:call-template name="renderFormBeanPropertiesAsForm">
                                        <xsl:with-param name="action" select="$actionType"/>
                                        <xsl:with-param name="form.classname" select="$form.classname" />
                                        <xsl:with-param name="skipFiles" select="'true'" />
                                    </xsl:call-template>
                                    <xsl:call-template name="renderFormHiddenFields">
                                        <xsl:with-param name="action" select="$action" />
                                    </xsl:call-template>
                                </fieldset>
                                <xsl:if test="$actionType != 'Search'">
                                    <fieldset>
                                        <legend>
                                            <bean:message key="{$action}.legend.files" />
                                        </legend>
                                        <xsl:call-template name="renderFormBeanPropertiesAsForm">
                                            <xsl:with-param name="action" select="$actionType"/>
                                            <xsl:with-param name="form.classname" select="$form.classname" />
                                            <xsl:with-param name="skipFiles" select="'false'" />
                                        </xsl:call-template>
                                    </fieldset>
                                </xsl:if>
                                <xsl:if test="$actionType = 'Search'">
                                    <fieldset>
                                        <legend>
                                            <bean:message key="legend.ordering"/>
                                        </legend>
                                        <dl class="md4jFormFieldItem">
                                            <dt class="md4jFormLabel">
                                                <label for="orderByPropertyName">
                                                    <logic:messagesPresent property="orderByPropertyName"> 
                                                        <span class="errorMessage">
                                                            <html:messages property="orderByPropertyName" id="msg">
                                                                <c:out value="{concat($dollar, $lbrace)}msg{$rbrace}"/>
                                                            </html:messages>
                                                        </span>
                                                    </logic:messagesPresent>
                                                    <logic:messagesNotPresent property="orderByPropertyName"> 
                                                        <bean:message key="orderByPropertyName"/>
                                                    </logic:messagesNotPresent>
                                                    <xsl:text>: &#10;</xsl:text>
                                                </label>
                                            </dt>
                                            <dd>
                                                <html:select property="orderByPropertyName" styleId="orderByPropertyName" styleClass="md4jFormInput">
                                                    <!--c:if test="{concat($dollar, $lbrace)} empty requestScope.{$form.classname}.orderByPropertyName{$rbrace}"-->
                                                        <!--option value="">
                                                            <bean:message key="please.select"/>
                                                        </option-->
                                                    <!--/c:if-->
                                                    <xsl:call-template name="renderOrderByPropertyNameOptions">
                                                        
                                                    </xsl:call-template>
                                                    <!--c:forEach items="${requestScope.{$form.classname}.parentSelectOptions['gr.abiss.md4j.util.Md4jGlobals.PARENT_OPTIONS#country']}" var="item">
                                                        <html:option value="${item.key}">
                                                        <c:out value="${item.value}"/>
                                                        </html:option>
                                                        </c:forEach-->
                                                </html:select>
                                            </dd>
                                        </dl>                                        
                                        <dl class="md4jFormFieldItem">
                                            <dt class="md4jFormLabel">
                                                <label for="orderByAscending">
                                                    <logic:messagesPresent property="orderByAscending"> 
                                                        <span class="errorMessage">
                                                            <html:messages property="orderByAscending" id="msg">
                                                                <c:out value="{concat($dollar, $lbrace)}msg{$rbrace}"/>
                                                            </html:messages>
                                                        </span>
                                                    </logic:messagesPresent>
                                                    <logic:messagesNotPresent property="orderByAscending"> 
                                                        <bean:message key="orderByAscending"/>
                                                    </logic:messagesNotPresent>
                                                    <xsl:text>: &#10;</xsl:text>
                                                </label>
                                            </dt>
                                            <dd>
                                                <html:select property="orderByAscending" styleId="orderByAscending" styleClass="orderByAscending">
                                                    <html:option value="true">
                                                        <bean:message key="ascending"/>
                                                    </html:option>
                                                    <html:option value="false">
                                                        <bean:message key="descending"/>
                                                    </html:option>
                                                </html:select>
                                            </dd>
                                        </dl>
                                    </fieldset>
                                </xsl:if>
                                <button type="submit" class="md4jFormButton">Submit</button>
                                <button type="reset" class="md4jFormButton">Reset</button>                                
                            </html:form>
                        </div>
                    </div>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:if test="$actionType = 'LoadUpdate'">
                <table summary="{$classname} links" class="form" cellspacing="0">
                    <xsl:call-template name="renderChildrenActionLinks">
                        <xsl:with-param name="classname" select="$classname"/>
                        <xsl:with-param name="form.classname" select="$form.classname"/>
                        <xsl:with-param name="identifier.name" select="$identifier.name"/>
                    </xsl:call-template>
                </table>
            </xsl:if>
            <!-- render search results ifthis is a search page -->
            <xsl:if test="$actionType ='Search'">
                <c:if test="{concat($dollar, $lbrace, 'not empty requestScope.results', $rbrace)}">
                    <div id="Product">
                        <h3>
                            <bean:message key="search.results" />
                        </h3>
                        <div class="left">
                            <div class="right">
                                <div class="center">
                    <c:if test="{concat($dollar, $lbrace, 'empty requestScope.results.list', $rbrace)}">
                        <p><bean:message key="seach.no.results.found" /></p>
                    </c:if>
                    <c:if test="{concat($dollar, $lbrace, 'not empty requestScope.results.list', $rbrace)}">
                        <xsl:call-template name="buildSearchUrl">
                            <xsl:with-param name="search.class" select="$classname" />
                            <xsl:with-param name="form.classname" select="$form.classname" />
                        </xsl:call-template>
                        <jsp:directive.include file="../md4j-dep/paging.inc" />
                        <xsl:choose>
                            <xsl:when test="string(meta[@attribute = 'md4j:search-results-tabular'][1]) = 'false'">
                                <div class="md4jSearchResults">
                                    <logic:iterate id="item" indexId="counter" name="results" property="list" type="java.util.Map" scope="request">
                                        <!--product begin -->
                                        <div class="md4jSearchResult">
                                            <h4>
                                                <html:link action="/{$classname}/View.do?{$identifier.name}={concat($dollar, $lbrace)}item.{$identifier.name}{$rbrace}">
                                                    <xsl:choose>
                                                        <xsl:when test="property[meta/@attribute = 'md4j:render-as-title']">
                                                            <xsl:for-each select="property[meta/@attribute = 'md4j:render-as-title']">
                                                                <xsl:call-template name="renderProperty">
                                                                </xsl:call-template>
                                                                <span><jsp:text><xsl:text> </xsl:text></jsp:text></span>
                                                            </xsl:for-each>
                                                        </xsl:when>
                                                        <xsl:otherwise>
                                                            <p>
                                                                <xsl:value-of select="concat('actionLowcase: ', $actionLowcase)"/>
                                                            </p>
                                                            <xsl:for-each select="property[not(meta/@attribute = 'md4j:render-not-as-title') and not(meta/@attribute = concat('md4j:on', $actionLowcase, '-ignore-for-projections'))][1]">
                                                                <xsl:call-template name="renderProperty">
                                                                </xsl:call-template>
                                                            </xsl:for-each>
                                                        </xsl:otherwise>
                                                    </xsl:choose>
                                                </html:link>
                                            </h4>
                                            <xsl:for-each select="property[meta/@attribute[contains(., 'md4j:render-as-image-thumb')]][1]">
                                                <!--span-->
                                                    <html:link styleClass="md4jThumb" action="/{$classname}/View.do?{$identifier.name}={concat($dollar, $lbrace)}item.{$identifier.name}{$rbrace}">
                                                        <html:img styleClass="md4jThumbImg" src="{concat(string(meta[@attribute = 'md4j:render-as-image-thumb-url-prefix'][1]), $dollar, $lbrace, 'requestScope.', $form.classname, '.', @name, $rbrace, string(meta[@attribute = 'md4j:render-as-image-thumb-url-suffix'][1]))}">
                                                            <xsl:if test="meta[@attribute = 'md4j:render-as-image-thumb-style']">
                                                                <xsl:attribute name="style">
                                                                    <xsl:value-of select="meta[@attribute = 'md4j:render-as-image-thumb-style'][1]"/>
                                                                </xsl:attribute>
                                                            </xsl:if>
                                                            <xsl:if test="meta[@attribute = 'md4j:render-as-image-thumb-width']">
                                                                <xsl:attribute name="width">
                                                                    <xsl:value-of select="meta[@attribute = 'md4j:render-as-image-thumb-width'][1]"/>
                                                                </xsl:attribute>
                                                            </xsl:if>
                                                            <xsl:if test="meta[@attribute = 'md4j:render-as-image-thumb-height']">
                                                                <xsl:attribute name="height">
                                                                    <xsl:value-of select="meta[@attribute = 'md4j:render-as-image-thumb-height'][1]"/>
                                                                </xsl:attribute>
                                                            </xsl:if>
                                                        </html:img>
                                                    </html:link>
                                                <!--/span-->
                                            </xsl:for-each>
                                            <dl class="details">
                                                <xsl:for-each select="property[not(meta/@attribute = 'md4j:render-as-image') and not(meta/@attribute = 'md4j:render-as-title' or meta/@attribute = concat('md4j:on', $actionLowcase, '-ignore-for-projections'))][position() &lt; 5]">
                                                    <c:if test="{concat($dollar, $lbrace)} not empty item.{@name}{$rbrace}">
                                                        <dt>
                                                            <xsl:call-template name="renderPropertyLabel"></xsl:call-template>
                                                        </dt>
                                                        <dd>
                                                            <xsl:call-template name="renderProperty"></xsl:call-template>
                                                        </dd>
                                                    </c:if>
                                                </xsl:for-each>
                                            </dl>
                                        </div>					
                                        <!--product end -->
                                    </logic:iterate>
                                </div>
                            </xsl:when>
                            <xsl:otherwise>
                                <table summary="Search results" class="md4jSearchResultsCompact" cellspacing="0">
                                    <tr class="md4jSearchResultsHeading">
                                        <xsl:for-each select="id[generator/@class='assigned'] | property[not(@formula)]">
                                            <xsl:if test="not(string(meta[@attribute = concat('md4j:on', $actionLowcase, '-ignore-for-projections')][1]) = 'true')">
                                                <!-- TODO: render property labels -->
                                                <th>
                                                    <xsl:call-template name="renderPropertyLabel"/>
                                                </th>
                                            </xsl:if>
                                        </xsl:for-each>
                                        <th>
                                            <bean:message key="view.details" />
                                        </th>
                                    </tr>
                                    <logic:iterate id="item" indexId="counter" name="results" property="list" type="java.util.Map" scope="request">
                                        <tr class="{concat('md4jSearchResultsRow', $dollar, $lbrace, 'counter % 2', $rbrace)}">
                                            <xsl:for-each select="id[generator/@class='assigned'] | property[not(@formula)]">
                                                <xsl:if test="not(string(meta[@attribute = concat('md4j:on', $actionLowcase, '-ignore-for-projections')][1]) = 'true')">
                                                    <td>
                                                        <xsl:call-template name="renderPropertyValue"/>
                                                    </td>
                                                </xsl:if>
                                            </xsl:for-each>
                                            <td>
                                                <html:link action="/{$classname}/View.do"
                                                    paramId="{$identifier.name}"
                                                    paramName="item"
                                                    paramProperty="{$identifier.name}"
                                                    >
                                                    <!--html:link action="/{$classname}/View.do?{$identifier.name}={concat($dollar, $lbrace)}pageContext.item.{$identifier.name}{$rbrace}"-->
                                                        <img src="{concat($dollar, $lbrace, 'pageContext.request.contextPath', $rbrace)}/images/famfamfam/icons/application_view_detail.png" 
                                                        altKey="view.details"/>
                                                </html:link>
                                            </td>    
                                        </tr>
                                    </logic:iterate>
                                </table>
                            </xsl:otherwise>
                        </xsl:choose>
                        <jsp:directive.include file="../md4j-dep/paging.inc" />
                    </c:if>
                    </div>
                    </div>
                    </div>
                    </div>
                    
                </c:if>    
            </xsl:if>
            <jsp:directive.include file="../md4j-dep/footer.inc" />
         </jsp:root>
    </xsl:template>
    <xsl:template name="renderProperty">
        <xsl:choose>
            <xsl:when test="meta[@attribute = 'md4j:use-value-as-key']">
                <bean:message key="{concat($dollar, $lbrace)}item.{@name}{$rbrace}"/>
            </xsl:when>
            <xsl:otherwise>
                <c:out value="{concat($dollar, $lbrace)}item.{@name}{$rbrace}"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
    <xsl:template name="renderOrderByPropertyNameOptions" mode="renderOrderByPropertyNameOptions">
        <xsl:for-each select="id | property[not(@formula)] | many-to-one">
            <xsl:if test="not(meta[@attribute = concat('md4j:on', $actionLowcase, '-ignore-for-projections')][1] = 'true')">
                <html:option value="{@name}">
                    <xsl:call-template name="renderPropertyLabel"/>
                </html:option>
            </xsl:if>
        </xsl:for-each>
    </xsl:template>
    
    <xsl:template name="renderFormBeanPropertiesAsForm">
        <xsl:param name="action"/>
        <xsl:param name="form.classname"/>
        <xsl:param name="skipFiles" select="'false'" />
        <!-- the var used to skip files in XPath expr -->
        <xsl:variable name="matchWhereMetaFileFlagCountIs">
            <xsl:choose>
                <xsl:when test="$skipFiles = 'true'">
                    <xsl:value-of select="0"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="1"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:variable name="dlClass">
            <xsl:choose>
                <xsl:when test="$skipFiles = 'true'">
                    <xsl:value-of select="'md4jFormFieldItem'"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="'md4jImageThumbItem'"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:variable name="inputClass">
            <xsl:choose>
                <xsl:when test="$skipFiles = 'true'">
                    <xsl:value-of select="'md4jFormFieldItem'"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="'md4jFormInputFile'"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <!-- [count(meta[@attribute = 'md4j:is-file']) = $matchWhereMetaFileFlagCountIs]
        -->
        <xsl:variable name="actionLowcase">
            <xsl:call-template name="hbm2all:string.toLowerCamel">
                <xsl:with-param name="string" select="$action" />
            </xsl:call-template>
        </xsl:variable>
        <xsl:if test="contains(local-name(), 'subclass')">
            <xsl:variable name="superclass">
                <xsl:call-template name="hbm2all:name.toUnqualifiedClassname">
                    <xsl:with-param name="name" select="@extends" />
                </xsl:call-template>
            </xsl:variable>
            <xsl:for-each select="document(concat($superclass, '.hbm.xml'), .)/hibernate-mapping/class[@name = $superclass]">
                <xsl:call-template name="renderFormBeanPropertiesAsForm">
                    <xsl:with-param name="action" select="$action" />
                    <xsl:with-param name="form.classname" select="$form.classname" />
                </xsl:call-template>
            </xsl:for-each>
        </xsl:if>
        
        <xsl:comment>Start properties of <xsl:value-of select="@name"/> </xsl:comment>
        <xsl:for-each select="id[($actionType = 'Create' or $actionType = 'Search') and generator/@class='assigned'][count(meta[@attribute = 'md4j:is-file']) = $matchWhereMetaFileFlagCountIs] | property[not(@formula)][count(meta[@attribute = 'md4j:is-file']) = $matchWhereMetaFileFlagCountIs] | many-to-one[count(meta[@attribute = 'md4j:is-file']) = $matchWhereMetaFileFlagCountIs]">
            
            <xsl:if test="not(string(meta[@attribute = concat('md4j:on', $actionLowcase, '-ignore-for-form')][1]) = 'true')">
            <!--xsl:if test="not(meta[@attribute = concat('md4j:on', $actionLowcase, '-ignore-for-projections') or @attribute = 'md4j:onsearch-ignore-for-form']) and not(@type = 'boolean' or @type = 'java.lang.Boolean')"-->
                &propertyScopeVars;            
                <dl class="{$dlClass}">
                    <dt class="md4jFormLabel">
                        <label for="{@name}">
                            <logic:messagesPresent property="{@name}"> 
                                <span class="errorMessage">
                                    <html:messages property="{@name}" id="msg">
                                        <c:out value="{concat($dollar, $lbrace)}msg{$rbrace}"/>
                                    </html:messages>
                                </span>
                            </logic:messagesPresent>
                            <logic:messagesNotPresent property="{@name}"> 
                                <xsl:choose>
                                    <xsl:when test="meta[@attribute = 'md4j:form-label-key']">
                                        <xsl:if test="string-length(meta[@attribute = 'md4j:form-label-key'][1]) &gt; 0">
                                            <bean:message key="{meta[@attribute = 'md4j:form-label-key']}"/>
                                        </xsl:if>
                                    </xsl:when>
                                    <xsl:when test="meta[@attribute = 'md4j:form-label']">
                                        <xsl:value-of select="meta[@attribute = 'md4j:form-label']"/>
                                    </xsl:when>
                                    <xsl:when test="$usePropertyNamesAsI18nKeys = 'true'">
                                        <bean:message key="{@name}"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <bean:message key="{concat($form.classname, '.', @name)}" />
                                    </xsl:otherwise>
                                </xsl:choose>
                            </logic:messagesNotPresent>
                            <xsl:text>: &#10;</xsl:text>
                        </label>
                    </dt>
                    <dd>
                        <xsl:choose>
                            <xsl:when test="string(meta[@attribute = 'md4j:is-file'][1]) = 'true'">
                                <html:file property="{@name}FormFile" styleClass="{$inputClass}" />
                            </xsl:when>
                            <xsl:when test="local-name() = 'many-to-one' or (@type = 'boolean' or @type = 'java.lang.Boolean')">
                                <html:select property="{@name}" styleId="{@name}" styleClass="md4jFormInput">
                                    <xsl:if test="string(meta[@attribute = concat('md4j:on', $actionLowcase, '-readonly')][1]) = 'true'">
                                        <xsl:attribute name="disabled">true</xsl:attribute>
                                    </xsl:if>
                                    <c:if test="{concat($dollar, $lbrace, ' empty requestScope.', $form.classname, '.', @name, $rbrace)}">
                                        <option value=""><bean:message key="please.select"/></option>
                                    </c:if>
                                    <xsl:choose>
                                        <xsl:when test="@type = 'boolean' or @type = 'java.lang.Boolean'">
                                            <html:option value="true" key="yes"/>
                                            <html:option value="false" key="no"/>
                                        </xsl:when>
                                        <xsl:when test="meta[@attribute = 'md4j:project-property-key']">
                                            <c:forEach items="{concat($dollar, $lbrace, 'requestScope.', $form.classname)}.parentSelectOptions['gr.abiss.md4j.util.Md4jGlobals.PARENT_OPTIONS#{@name}']{$rbrace}" var="item">
                                                <html:option value="{concat($dollar, $lbrace)}item.key{$rbrace}" key="{concat($dollar, $lbrace)}item.value{$rbrace}"/>
                                            </c:forEach>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <c:forEach items="{concat($dollar, $lbrace, 'requestScope.', $form.classname)}.parentSelectOptions['gr.abiss.md4j.util.Md4jGlobals.PARENT_OPTIONS#{@name}']{$rbrace}" var="item">
                                                <html:option value="{concat($dollar, $lbrace)}item.key{$rbrace}">
                                                    <c:out value="{concat($dollar, $lbrace)}item.value{$rbrace}"/>
                                                </html:option>
                                            </c:forEach>
                                        </xsl:otherwise>
                                    </xsl:choose>
                                </html:select>
                            </xsl:when>
                            <xsl:otherwise>
                                <html:text property="{@name}" styleId="{@name}" styleClass="md4jFormInput">
                                    <xsl:if test="string(meta[@attribute = concat('md4j:on', $actionLowcase, '-readonly')][1]) = 'true'">
                                        <xsl:attribute name="disabled">true</xsl:attribute>
                                    </xsl:if>
                                    <xsl:if test="local-name() = 'id' and $actionType = 'LoadUpdate'">
                                        <xsl:attribute name="readonly">
                                            <xsl:value-of select="'true'"/>
                                        </xsl:attribute>
                                    </xsl:if>
                                    <xsl:if test="@length">
                                        <xsl:attribute name="maxlength">
                                            <xsl:value-of select="@length"/>
                                        </xsl:attribute>
                                    </xsl:if>
                                    <!--xsl:if test="local-name() = 'id' and $action = 'update'">
                                        <xsl:attribute name="disabled">
                                        <xsl:value-of select="'disabled'"/>
                                        </xsl:attribute>
                                        </xsl:if-->
                                </html:text>
                                <!-- TODO: work on date/time format and further config -->
                                <xsl:if test="$hbmtype = 'date' or $hbmtype = 'java.util.Date' or $hbmtype = 'time' or $hbmtype = 'timestamp' or $hbmtype = 'java.sql.Timestamp' or $hbmtype = 'calendar' or $hbmtype = 'java.util.Calendar' or $hbmtype = 'calendar_date'">
                                    <script type="text/javascript">
                                        <jsp:text>// &lt;![[</jsp:text>
                                        Calendar.setup({
                                        inputField : "<xsl:value-of select="@name"/>",
                                        eventName  : "focus", 
                                        ifFormat   : "%d/%m/%Y",
                                        showsTime  : false,
                                        timeFormat : "24"
                                        });
                                        <jsp:text>// ]]&gt;</jsp:text>
                                    </script>
                                </xsl:if>
                            </xsl:otherwise>
                        </xsl:choose>
                    </dd> 
                    
                    <xsl:if test="string(meta[@attribute = 'md4j:render-as-image'][1]) = 'true' and $skipFiles = 'false'">
                        <c:if test="{concat($dollar, $lbrace)} not empty requestScope.{$form.classname}.{@name}{$rbrace}">
                            <dd class="updateExistingThumbPreview">
                            <span class="">
                                <!--a href="{concat(string(meta[@attribute = 'md4j:render-as-image-url-prefix'][1]), $dollar, $lbrace, 'requestScope.', $form.classname, '.', @name, $rbrace, string(meta[@attribute = 'md4j:render-as-image-url-suffix'][1]))}" 
                                rel="lightbox"-->
                            <html:img src="{concat(string(meta[@attribute = 'md4j:render-as-image-thumb-url-prefix'][1]), $dollar, $lbrace, 'requestScope.', $form.classname, '.', @name, $rbrace, string(meta[@attribute = 'md4j:render-as-image-thumb-url-suffix'][1]))}">
                                <xsl:if test="meta[@attribute = 'md4j:render-as-image-thumb-style']">
                                    <xsl:attribute name="style">
                                        <xsl:value-of select="meta[@attribute = 'md4j:render-as-image-thumb-style'][1]"/>
                                    </xsl:attribute>
                                </xsl:if>
                                <xsl:if test="meta[@attribute = 'md4j:render-as-image-thumb-width']">
                                    <xsl:attribute name="width">
                                        <xsl:value-of select="meta[@attribute = 'md4j:render-as-image-thumb-width'][1]"/>
                                    </xsl:attribute>
                                </xsl:if>
                                <xsl:if test="meta[@attribute = 'md4j:render-as-image-thumb-height']">
                                    <xsl:attribute name="height">
                                        <xsl:value-of select="meta[@attribute = 'md4j:render-as-image-thumb-height'][1]"/>
                                    </xsl:attribute>
                                </xsl:if>
                            </html:img>
                            <!--/a-->
                            </span>
                            </dd>
                        </c:if>
                    </xsl:if>
                </dl>
            </xsl:if>
        </xsl:for-each>
        <xsl:comment>End properties of <xsl:value-of select="@name"/> </xsl:comment>
    </xsl:template>
    
    <xsl:template name="renderFormHiddenFields">
        <xsl:param name="action"/>
        <xsl:if test="contains(local-name(), 'subclass')">
            <xsl:variable name="superclass">
                <xsl:call-template name="hbm2all:name.toUnqualifiedClassname">
                    <xsl:with-param name="name" select="@extends" />
                </xsl:call-template>
            </xsl:variable>
            <xsl:for-each select="document(concat($superclass, '.hbm.xml'), .)/hibernate-mapping/class[@name = $superclass]">
                <xsl:call-template name="renderFormHiddenFields" >
                    <xsl:with-param name="action" select="$action" />
                </xsl:call-template>
            </xsl:for-each>
        </xsl:if>
        <xsl:if test="$actionType = 'Update'">
            <xsl:for-each select="id">
                &propertyScopeVars;
                <html:hidden property="{@name}" />
            </xsl:for-each>
        </xsl:if>
    </xsl:template>
    
    <xsl:template name="renderFormBeanPropertiesAsView">
        <xsl:param name="action"/>
        <xsl:param name="actionLowcase"/>
        <xsl:param name="form.classname"/>
        
        <xsl:param name="skipFiles" select="'false'" />
        <!-- the var used to skip files in XPath expr -->
        <xsl:variable name="matchWhereMetaFileFlagCountIs">
            <xsl:choose>
                <xsl:when test="$skipFiles = 'true'">
                    <xsl:value-of select="0"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="1"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:variable name="dlClass">
            <xsl:choose>
                <xsl:when test="$skipFiles = 'true'">
                    <xsl:value-of select="'md4jFormFieldItem'"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="'md4jImageThumbItem'"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <!-- [count(meta[@attribute = 'md4j:is-file']) = $matchWhereMetaFileFlagCountIs]
        -->
        
        <xsl:if test="contains(local-name(), 'subclass')">
            <xsl:variable name="superclass">
                <xsl:call-template name="hbm2all:name.toUnqualifiedClassname">
                    <xsl:with-param name="name" select="@extends" />
                </xsl:call-template>
            </xsl:variable>
            <xsl:for-each select="document(concat($superclass, '.hbm.xml'), .)/hibernate-mapping/class[@name = $superclass]">
                <xsl:call-template name="renderFormBeanPropertiesAsView">
                    <xsl:with-param name="action" select="$action" />
                    <xsl:with-param name="actionLowcase" select="$actionLowcase" />
                    <xsl:with-param name="form.classname" select="$form.classname" />
                </xsl:call-template>
            </xsl:for-each>
        </xsl:if>
        <xsl:comment>Properties of <xsl:value-of select="@name"/>: </xsl:comment>
        <xsl:comment><xsl:value-of select="concat('// actionLowcase: ', $actionLowcase)"/></xsl:comment>
        <xsl:for-each select="id[generator/@class='assigned'][count(meta[@attribute = 'md4j:is-file']) = $matchWhereMetaFileFlagCountIs] | property[count(meta[@attribute = 'md4j:is-file']) = $matchWhereMetaFileFlagCountIs] | many-to-one[count(meta[@attribute = 'md4j:is-file']) = $matchWhereMetaFileFlagCountIs]">
            <xsl:if test="not(string(meta[@attribute = concat('md4j:on', $actionLowcase, '-ignore-for-projections')][1]) = 'true')">
                <!-- &propertyScopeVars; -->
                
                <c:if test="{concat($dollar, $lbrace)} not empty requestScope.{$form.classname}.{@name}{$rbrace}">
                    <dl class="{$dlClass}">
                        <dt class="md4jFormLabel">
                            <xsl:call-template name="renderPropertyLabel"/>
                            <xsl:text>: </xsl:text>
                        </dt>
                        <dd>
                            <xsl:choose>
                                <xsl:when test="string(meta[@attribute = 'md4j:render-as-image'][1]) = 'true'">
                                    <span class="image">
                                        <a href="{concat(string(meta[@attribute = 'md4j:render-as-image-url-prefix'][1]), $dollar, $lbrace, 'requestScope.', $form.classname, '.', @name, $rbrace, string(meta[@attribute = 'md4j:render-as-image-url-suffix'][1]))}" 
                                            rel="lightbox[group]">
                                            
                                    <html:img src="{concat(string(meta[@attribute = 'md4j:render-as-image-thumb-url-prefix'][1]), $dollar, $lbrace, 'requestScope.', $form.classname, '.', @name, $rbrace, string(meta[@attribute = 'md4j:render-as-image-thumb-url-suffix'][1]))}">
                                        <xsl:if test="meta[@attribute = 'md4j:render-as-image-thumb-style']">
                                            <xsl:attribute name="style">
                                                <xsl:value-of select="meta[@attribute = 'md4j:render-as-image-thumb-style'][1]"/>
                                            </xsl:attribute>
                                        </xsl:if>
                                        <xsl:if test="meta[@attribute = 'md4j:render-as-image-thumb-width']">
                                            <xsl:attribute name="width">
                                                <xsl:value-of select="meta[@attribute = 'md4j:render-as-image-thumb-width'][1]"/>
                                            </xsl:attribute>
                                        </xsl:if>
                                        <xsl:if test="meta[@attribute = 'md4j:render-as-image-thumb-height']">
                                            <xsl:attribute name="height">
                                                <xsl:value-of select="meta[@attribute = 'md4j:render-as-image-thumb-height'][1]"/>
                                            </xsl:attribute>
                                        </xsl:if>
                                    </html:img></a></span>
                                </xsl:when>
                                <xsl:when test="string(meta[@attribute = 'md4j:is-file'][1]) = 'true'">
                                    <html:link href="{concat(string(meta[@attribute = 'md4j:render-as-image-url-prefix'][1]), $dollar, $lbrace, 'requestScope.', $form.classname, '.', @name, $rbrace, string(meta[@attribute = 'md4j:render-as-image-url-suffix'][1]))}">
                                        <xsl:if test="meta['md4j:render-as-image-styleclass']">
                                            <xsl:attribute name="styleClass">
                                                <xsl:value-of select="meta['md4j:render-as-image-styleclass'][1]"/>
                                            </xsl:attribute>
                                        </xsl:if>
                                    </html:link>
                                </xsl:when>
                                <xsl:when test="meta[@attribute = 'md4j:use-value-as-key']">
                                    <bean:message name="{$form.classname}" property="{@name}" scope="request"/>
                                </xsl:when>
                                <xsl:otherwise>
                                    <bean:write name="{$form.classname}" property="{@name}" scope="request"/>
                                </xsl:otherwise>
                            </xsl:choose>
                        </dd>   
                    </dl>
                </c:if>
            </xsl:if>
        </xsl:for-each>
    </xsl:template>
    <xsl:template name="renderPropertyLabel">
        <xsl:choose>
            <xsl:when test="meta[@attribute = 'md4j:form-label-key']">
                <bean:message key="{meta[@attribute = 'md4j:form-label-key']}"/>
            </xsl:when>
            <xsl:when test="meta[@attribute = 'md4j:form-label']">
                <xsl:value-of select="meta[@attribute = 'md4j:form-label']"/>
            </xsl:when>
            <xsl:when test="$usePropertyNamesAsI18nKeys = 'true'">
                <bean:message key="{@name}"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="@name"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <!-- replace with renderProperty -->
    <xsl:template name="renderPropertyValue">
        <bean:write name="item" property="{@name}" scope="page"/>
    </xsl:template>
    
    <xsl:template name="buildSearchUrl">
        <xsl:param name="search.class" />
        <xsl:param name="form.classname" />
        <c:url value="/{$search.class}/Search.do" var="searchUrl" scope="page">
            <xsl:for-each select="id[generator/@class='assigned'] | property[not(@formula)] | many-to-one">
                &propertyScopeVars;
                <c:param name="{@name}" value="{concat($dollar, $lbrace, 'requestScope.', $form.classname, '.', @name, $rbrace)}"/>
            </xsl:for-each>
            <c:param name="orderByAscending" value="{concat($dollar, $lbrace, 'requestScope.', $form.classname, '.orderByAscending', $rbrace)}"/>
            <c:param name="orderByPropertyName" value="{concat($dollar, $lbrace, 'requestScope.', $form.classname, '.orderByPropertyName', $rbrace)}"/>
        </c:url>
    </xsl:template>
    
    
    <xsl:template name="renderChildrenActionLinks">
        <xsl:param name="classname"/>
        <xsl:param name="form.classname" />
        <xsl:param name="identifier.name" />
        <xsl:if test="contains(local-name(), 'subclass')">
            <xsl:variable name="superclass">
                <xsl:call-template name="hbm2all:name.toUnqualifiedClassname">
                    <xsl:with-param name="name" select="@extends" />
                </xsl:call-template>
            </xsl:variable>
            <xsl:for-each select="document(concat($superclass, '.hbm.xml'), .)/hibernate-mapping/class[@name = $superclass]">
                <xsl:call-template name="renderChildrenActionLinks" />
            </xsl:for-each>
        </xsl:if>
        <xsl:comment><xsl:value-of select="concat(@name, 'children actions:')"/></xsl:comment>
        <!--  -->
        <xsl:for-each select="*[local-name() = 'bag' or local-name() = 'list' or local-name() = 'set'][meta/@attribute = 'md4j:collection-reverse-property']">
            &propertyScopeVars;
            <xsl:variable name="child.classname">
                <xsl:call-template name="hbm2all:name.toUnqualifiedClassname">
                    <xsl:with-param name="name" select="one-to-many/@class" />
                </xsl:call-template>
            </xsl:variable>
            <tr>
                <td class="title">
                    <!--p>child.classname: <xsl:value-of select="$child.classname"/></p-->
                    <xsl:call-template name="renderPropertyLabel"/>
                    <xsl:text>: &#10;</xsl:text>
                </td>
                <td>
                    <c:url value="{concat('/', $child.classname, '/Search.do')}" var="{concat(@name, 'searchUrl')}" scope="page">
                        <c:param name="{meta[@attribute = 'md4j:collection-reverse-property']}" value="{concat($dollar, $lbrace, 'requestScope.', $form.classname, '.', $identifier.name, $rbrace)}"/>
                    </c:url>
                    <a href="{concat($dollar, $lbrace, 'pageScope.', @name, 'searchUrl', $rbrace)}">
                        <bean:message key="view"/>
                    </a>
                </td>   
                <td>
                    <c:url value="{concat('/', $child.classname, '/LoadCreate.do')}" var="{concat(@name, 'createUrl')}" scope="page">
                        <c:param name="{meta[@attribute = 'md4j:collection-reverse-property']}" value="{concat($dollar, $lbrace, 'requestScope.', $form.classname, '.', $identifier.name, $rbrace)}"/>
                    </c:url>
                    <a href="{concat($dollar, $lbrace, 'pageScope.', @name, 'createUrl', $rbrace)}">
                        <bean:message key="add"/>
                    </a>
                </td>   
            </tr>
        </xsl:for-each>
    </xsl:template>
    
</xsl:stylesheet>