<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE includes [
  <!ENTITY classScopeVars SYSTEM "classTemplateVars.inc">
  <!ENTITY getEJB SYSTEM "getEJB.inc">
  <!ENTITY getParams SYSTEM "getParams.xml">
  <!ENTITY propertyScopeVars SYSTEM "propertyScopeVars.inc">
  <!ENTITY licenseBlock SYSTEM "license.inc">
  ]>   
<!-- 
    /*
    * Copyright 2004-2005 Emmanouil Batsis
    * 
    * Licensed under the GNU General Public License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    * 
    *      http://www.gnu.org/licenses/gpl.txt
    * 
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * 
    */
-->
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
    xmlns:hbm2all="http://geekologue.com/ns/hbm4all/">
    <xsl:output method="text" encoding="UTF-8" media-type="text/x-java-source"/>
    <xsl:include href="md4j-util.xsl"/>
    
    <xsl:template match="class|joined-subclass|subclass">
        <xsl:variable name="extends">
            <xsl:value-of select="'Action'"/>
            <!--xsl:choose>
                <xsl:when test="@extends">
                    <xsl:value-of select="concat(@extends, $actionType,  'Action')" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="'Action'"/>
                </xsl:otherwise>
            </xsl:choose-->
        </xsl:variable>
        &classScopeVars;
        <xsl:text>&licenseBlock;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:value-of select="concat('package ', $package, '.web;&#10;')"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import java.io.Serializable;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import java.util.Map;&#10;</xsl:text>
        <xsl:text>import java.util.HashMap;&#10;</xsl:text>
        <xsl:text>import java.util.Set;&#10;</xsl:text>
        <xsl:text>import java.util.HashSet;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import java.text.SimpleDateFormat;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import javax.servlet.http.HttpServletRequest;&#10;</xsl:text>
        <xsl:text>import javax.servlet.http.HttpServletResponse;&#10;</xsl:text>
        <xsl:text>import javax.servlet.http.HttpSession;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import org.apache.log4j.Logger;&#10;</xsl:text>
        <xsl:text>import org.apache.commons.lang.math.NumberUtils;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>import org.apache.struts.action.ActionForm;&#10;</xsl:text>
        <xsl:text>import org.apache.struts.action.ActionForward;&#10;</xsl:text>
        <xsl:text>import org.apache.struts.action.ActionErrors;&#10;</xsl:text>
        <xsl:text>import org.apache.struts.action.ActionMapping;&#10;</xsl:text>
        <xsl:text>import org.apache.struts.action.ActionMessages;&#10;</xsl:text>
        <xsl:text>import org.apache.struts.upload.MultipartRequestHandler;&#10;</xsl:text>
        
        <xsl:text>&#10;</xsl:text>
        <!--xsl:if test="$extends = 'AbstractSearchAction'">
            <xsl:text>import gr.abiss.md4j.dto.File;&#10;</xsl:text>
            <xsl:text>import gr.abiss.md4j.web.AbstractSearchAction;&#10;</xsl:text>
        </xsl:if-->
        <xsl:if test="$extends = 'Action'">
            <xsl:text>import org.apache.struts.action.Action;&#10;</xsl:text>
        </xsl:if>
        <xsl:text>import gr.abiss.md4j.dao.Page;&#10;</xsl:text>
        <xsl:text>import gr.abiss.md4j.util.StringUtil;&#10;</xsl:text>
        <xsl:text>&#10;</xsl:text>
        <xsl:value-of select="concat('import ', $package, '.web.', $form.classname, ';&#10;')"/>
        <xsl:value-of select="concat('import ', $package,'.business.', $ejb.classname, ';&#10;')"/>
        <xsl:value-of select="concat('import ', $package, '.business.', $ejb.util.classname, ';&#10;')"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>/**&#10;</xsl:text>
        <xsl:value-of select="concat(' * @struts.action path=&quot;', $action.path, '&quot; &#10;')"/>
        <xsl:value-of select="concat(' *                         name=&quot;', $form.classname, '&quot;&#10;')"/>
        <xsl:value-of select="concat(' *                         input=&quot;', $input.path, '&quot;&#10;')"/>
        <xsl:text> *                         scope="request"&#10;</xsl:text>
        <xsl:value-of select="concat(' *                         validate=&quot;', $validate, '&quot;&#10;')"/>
        <xsl:text> *&#10;</xsl:text>
        <xsl:value-of select="concat(' * @struts.action-forward path=&quot;', $view.path, '&quot;&#10;')"/>
        <xsl:value-of select="concat(' *                         name=&quot;', $action.classname, 'View&quot;&#10;')"/>
        <xsl:text> *&#10;</xsl:text>
        <xsl:text> */&#10;</xsl:text>
        <xsl:value-of select="concat('public class ', $action.classname, ' extends ', $extends, '{&#10;')"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:value-of select="concat('    private static Logger log = Logger.getLogger(', $action.classname, '.class);&#10;')"/>
        <xsl:if test="not(string(meta[@attribute = 'md4j:load-projection-map']) = 'false')">
            <xsl:text>&#10;</xsl:text>
            <xsl:text>    /**&#10;</xsl:text>
            <xsl:text>     * A static, unmodifiable Set holding the projection properties.&#10;</xsl:text>
            <xsl:text>     * If you want these created at runtime in each &lt;code&gt;execute&lt;/code&gt; method call, &#10;</xsl:text>
            <xsl:text>     * simply set &lt;code&gt;md4j:use-instance-projections&lt;/code&gt; to &lt;code&gt;true&lt;/code&gt;.&#10;</xsl:text>
            <xsl:text>     */&#10;</xsl:text>
            <xsl:text>    private static Set projectionProps = new HashSet();&#10;</xsl:text>
            <xsl:text>    static{&#10;</xsl:text>
            <xsl:call-template name="generateProjections">
                <xsl:with-param name="action" select="$actionType"/>
                <xsl:with-param name="spaceIndent" select="'        '"/>
            </xsl:call-template>
            <xsl:text>        projectionProps = java.util.Collections.unmodifiableSet(projectionProps);&#10;</xsl:text>
            <xsl:text>    }&#10;</xsl:text>
            <xsl:text>&#10;</xsl:text>
        </xsl:if>
        <xsl:text>    /**&#10;</xsl:text>
        <xsl:text>     * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)&#10;</xsl:text>
        <xsl:text>     */&#10;</xsl:text>
        <xsl:text>    public ActionForward execute(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) {&#10;</xsl:text>
        <xsl:text>        String fwd = "error";&#10;</xsl:text>
        <xsl:text>        try{&#10;</xsl:text>
        <xsl:value-of select="concat('            ', $form.classname, ' form = (', $form.classname, ') actionForm;&#10;')"/>
        <!-- 
            Action execute code based on actionType
        -->
        <xsl:if test="$actionType = 'Search'">
            <xsl:text></xsl:text>
            <xsl:text>            Map params = form.toMap();&#10;</xsl:text>    
        </xsl:if>
        <!-- 
        Now get an EJB to do the search using the given params
        -->
        <xsl:choose>
            <!--xsl:when test="$actionType = 'View'">
                <xsl:value-of select="concat('            Object identifier = request.getAttribute(&quot;', $identifier.name, '&quot;);&#10;')"/>
                <xsl:value-of select="'            request.setAttribute(&quot;result&quot;, manager.get((java.io.Serializable) identifier));&#10;'"/>
                </xsl:when-->
            <xsl:when test="$actionType = 'View'">
                <xsl:value-of select="concat('            Serializable identifier = form.', $identifier.getter, '();&#10;')"/>
                <xsl:text>            if(identifier != null){&#10;</xsl:text>
                <xsl:text>                </xsl:text>&getEJB;
                <xsl:choose>
                    <xsl:when test="not(string(meta[@attribute = 'md4j:load-projection-map']) = 'false')">
                        <xsl:text>                // get the projected properties for the object maching the identifier &#10;</xsl:text>
                        <xsl:value-of select="concat('                Map map = manager.get(identifier, ', $action.classname, '.projectionProps);&#10;')"/>
                    </xsl:when>
                    <xsl:otherwise><!-- TODO: Needs fixing for POJO users to obtain POJO+parentOptions -->
                        <xsl:value-of select="concat('                Map map = manager.get(identifier, ', $action.classname, '.projectionProps);&#10;')"/>
                    </xsl:otherwise>
                </xsl:choose>
                <xsl:text>                // populate form bean from map&#10;</xsl:text>
                <xsl:value-of select="concat('', '                form.copyProperties(map);&#10;')" />
                <!-- remove this, add a method that wont return the parent options -->
                <xsl:text>                // populate form bean option data for drop downs&#10;</xsl:text>
                <xsl:value-of select="concat('', '                form.setParentSelectOptions(map);&#10;')" />
                <!-- TODO: is this line required? -->
                <xsl:value-of select="concat('                request.setAttribute(&quot;', $form.classname, '&quot;, form);&#10;')"/>
                <xsl:text>            }&#10;</xsl:text>
            </xsl:when>
            <xsl:when test="$actionType = 'LoadCreate'">
                <xsl:text>            </xsl:text>&getEJB;
                <xsl:text>            Map map = manager.getParentOptions();&#10;</xsl:text>
                <xsl:text>            // populate form bean option data for drop downs&#10;</xsl:text>
                <xsl:value-of select="concat('', '            form.setParentSelectOptions(map);&#10;')" />
                <!-- TODO: is this line required? -->
                <xsl:value-of select="concat('            request.setAttribute(&quot;', $form.classname, '&quot;, form);&#10;')"/>
            </xsl:when>
            <xsl:when test="$actionType = 'LoadUpdate'">
                <xsl:value-of select="concat('            Serializable identifier = form.', $identifier.getter, '();&#10;')"/>
                <xsl:text>            if(identifier != null){&#10;</xsl:text>
                <xsl:text>                // if we got here we will need a Session bean  &#10;</xsl:text>
                <xsl:text>                </xsl:text>&getEJB;
                <xsl:text>                if(this.isTokenValid(request)){&#10;</xsl:text>
                <xsl:text>                    // if the token is valid the form already has user-entered data so &#10;</xsl:text>
                <xsl:text>                    // we only want data to populate the drop down elements etc in the view &#10;</xsl:text>
                <xsl:value-of select="concat('                    Map map = manager.getParentOptions();&#10;', '')"/>
                <xsl:text>                    // populate form bean option data for drop downs&#10;</xsl:text>
                <xsl:value-of select="concat('', '                    form.setParentSelectOptions(map);&#10;')" />
                <xsl:text>                }&#10;</xsl:text>
                <xsl:text>                else{&#10;</xsl:text>
                <xsl:text>                    // otherwise, we need to load data for both the entity the user wishes to update &#10;</xsl:text>
                <xsl:text>                    // and for for the view's select options etc &#10;</xsl:text>
                <xsl:choose>
                    <xsl:when test="not(string(meta[@attribute = 'md4j:load-projection-map']) = 'false')">
                        <xsl:value-of select="concat('                    Map map = manager.getWithOptions(identifier, ', $action.classname, '.projectionProps);&#10;')"/>
                    </xsl:when>
                    <xsl:otherwise><!-- TODO: Needs fixing for POJO users to obtain POJO+parentOptions -->
                        <xsl:value-of select="concat('                    Map map = manager.getWithOptions(identifier, ', $action.classname, '.projectionProps);&#10;')"/>
                    </xsl:otherwise>
                </xsl:choose>
                <xsl:text>                    // populate form bean from map&#10;</xsl:text>
                <xsl:value-of select="concat('', '                    form.copyProperties(map);&#10;')" />
                <xsl:text>                    // populate form bean option data for drop downs&#10;</xsl:text>
                <xsl:value-of select="concat('', '                    form.setParentSelectOptions(map);&#10;')" />
                <xsl:text>                }&#10;</xsl:text>
                <!-- TODO: is this line required? -->
                <xsl:value-of select="concat('                request.setAttribute(&quot;', $form.classname, '&quot;, form);&#10;')"/>
                <xsl:text>            }&#10;</xsl:text>
            </xsl:when>
            <xsl:when test="$actionType = 'Search'">
                <xsl:variable name="pageGetter" select="'getResultsPageNumber'"/>
                <xsl:text>            // check if results need to be produced &#10;</xsl:text>
                <xsl:text>            if(params.size() > 0 || form.getOrder().getOrderProperties().size() > 0){ &#10;</xsl:text>
                <xsl:text>                </xsl:text>&getEJB;
                <xsl:text>                Integer pageNumber = form.getResultsPageNumber();&#10;</xsl:text>
                <xsl:choose>
                    <xsl:when test="not(string(meta[@attribute = 'md4j:load-projection-map']) = 'false')">
                        <xsl:choose>
                            <xsl:when test="string(meta[@attribute = 'md4j:use-instance-projections']) = 'true'">
                                <xsl:text>                // what properties we need from each of the results &#10;</xsl:text>
                                <xsl:text>                Set projectionProps = new HashSet();&#10;</xsl:text>
                                <xsl:call-template name="generateProjections"/>
                                <xsl:text>                // obtain a page of results and put it under in request context for the view&#10;</xsl:text>
                                <xsl:value-of select="concat('                Page page = manager.search(projectionProps, params, form.getOrder(), pageNumber != null?pageNumber.intValue():1, 10);&#10;', '')"/>
                                <xsl:value-of select="concat('                request.setAttribute(&quot;results&quot;, page);&#10;', '')"/>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:text>                // obtain a page of results and put it under in request context for the view&#10;</xsl:text>
                                <xsl:value-of select="concat('                Page page = manager.search(', $action.classname, '.projectionProps, params, form.getOrder(), pageNumber != null?pageNumber.intValue():1, 10);&#10;')"/>
                                <xsl:value-of select="concat('                request.setAttribute(&quot;results&quot;, page);&#10;', '')"/>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:text>                // obtain a page of results and put it under in request context for the view&#10;</xsl:text>
                        <xsl:value-of select="concat('                Page page = manager.search(params, form.getOrder(), pageNumber != null?pageNumber.intValue():1, 10);&#10;', '')"/>
                        <xsl:value-of select="concat('                request.setAttribute(&quot;results&quot;, page);&#10;', '')"/>
                    </xsl:otherwise>
                </xsl:choose>
                <xsl:text>                // populate form bean option data for drop downs&#10;</xsl:text>
                <xsl:value-of select="concat('', '                form.setParentSelectOptions(page.getParentOptions());&#10;')" />
                <xsl:text>            }&#10;</xsl:text>
                <xsl:text>            else{&#10;</xsl:text>
                <xsl:text>                </xsl:text>&getEJB;
                <!-- TODO: the DAOs may have already put the parent options in there -->
                <xsl:value-of select="concat('', '                form.setParentSelectOptions(manager.getParentOptions());&#10;')" />
                <xsl:text>            }&#10;</xsl:text>
                <!--xsl:text>            // save a token to signal results need to be rendered next time &#10;</xsl:text>
                <xsl:text>            this.saveToken(request);&#10;</xsl:text-->
            </xsl:when>
        </xsl:choose>
        <xsl:if test="$actionType = 'LoadCreate' or $actionType = 'LoadUpdate' ">
            <xsl:text>            // save a token to signal results need to be rendered next time &#10;</xsl:text>
            <xsl:text>            this.saveToken(request);&#10;</xsl:text>                
        </xsl:if>
        <xsl:value-of select="concat('            fwd = &quot;', $action.classname, 'View&quot;;&#10;')"/>

        <xsl:text>        } catch (Exception e) {&#10;</xsl:text>
        <!--xsl:text>            e.printStackTrace(); &#10;</xsl:text-->
        <xsl:if test="$actionType != 'Search'">
            <xsl:text>            // reset the token to avoid causing trouble &#10;</xsl:text>
            <xsl:text>            this.resetToken(request);&#10;</xsl:text>
        </xsl:if>
        <xsl:text>            log.error("Failed to perform search operation, wrapping to RuntimeException", e);&#10;</xsl:text>
        <xsl:text>            throw new RuntimeException(e);&#10;</xsl:text>
        <xsl:text>        }&#10;</xsl:text>
        <xsl:text>        return mapping.findForward(fwd);&#10;</xsl:text>
        <xsl:text>    }&#10;</xsl:text>
        <xsl:text>&#10;}&#10;</xsl:text>
    </xsl:template>
    
</xsl:transform>
