            <xsl:variable name="name" select="@name" />
            <xsl:variable name="relatedClass">
            	<xsl:if test="local-name() = 'many-to-one' or (local-name() = 'set' or local-name() = 'bag' or local-name() = 'list' or local-name() = 'array' or local-name() = 'set')">
                    <xsl:choose>
                        <xsl:when test="@class">
                            <xsl:value-of select="@class"/>
                        </xsl:when>
                        <xsl:when test="many-to-many">
                            <xsl:value-of select="many-to-many/@class"/>
                        </xsl:when>
                        <xsl:when test="one-to-many">
                            <xsl:value-of select="one-to-many/@class"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:message terminate="yes">Cannot find related class for <xsl:value-of select="local-name()"/>: <xsl:value-of select="@name"/></xsl:message>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:if>
            </xsl:variable>
            <!--todo: get identifier for related object -->
            <xsl:variable name="related.identifier.name">
            	<!-- TODO: fix for one-to-many, many-to-many -->
                <xsl:choose>
                    <xsl:when test="local-name() = 'many-to-one' or (local-name() = 'set' or local-name() = 'bag' or local-name() = 'list' or local-name() = 'array' or local-name() = 'set')">
                        <xsl:call-template name="hbm2all:get.superclass.identifier">
                            <xsl:with-param name="superclass" select="$relatedClass" />
                        </xsl:call-template>
                    </xsl:when>
                </xsl:choose>
            </xsl:variable>
            <xsl:variable name="hbmtype">
                <xsl:choose>
                    <xsl:when test="local-name() = 'many-to-one' or (local-name() = 'set' or local-name() = 'bag' or local-name() = 'list' or local-name() = 'array' or local-name() = 'set')">
                        <xsl:call-template name="hbm2all:get.superclass.identifier.type">
                            <xsl:with-param name="superclass" select="$relatedClass" />
                        </xsl:call-template>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="@type"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>
            <xsl:variable name="searchType">
                <xsl:call-template name="hbm2all:hbmtype.toSearchType">
                    <xsl:with-param name="hbmtype" select="$hbmtype"/>
                </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="javatype">
                <xsl:call-template name="hbm2all:type.hbm2JavaType">
                    <xsl:with-param name="type" select="$hbmtype"/>
                </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="type">
                <xsl:call-template name="hbm2all:hbmtype.toActionFormType">
                    <xsl:with-param name="hbmtype" select="$hbmtype"/>
                </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="getterName">
                <xsl:text>get</xsl:text>
                <xsl:call-template name="hbm2all:string.toUpperCamel">
                    <xsl:with-param name="string" select="@name" />
                </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="setterName">
                <xsl:text>set</xsl:text>
                <xsl:call-template name="hbm2all:string.toUpperCamel">
                    <xsl:with-param name="string" select="@name" />
                </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="join-type">
                <xsl:variable name="given-type" select="meta[@attribute = 'md4j:join-type']" />
                <xsl:choose>
                    <xsl:when test="$given-type='FULL_JOIN' or $given-type='INNER_JOIN' or$given-type='LEFT_JOIN'">
                        <xsl:value-of select="$given-type" />
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="'LEFT_JOIN'" />
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>